/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "read_config_yy.y"

/*
 * (C) 2006-2009 by Pablo Neira Ayuso <pablo@netfilter.org>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Description: configuration file abstract grammar
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <errno.h>
#include <stdarg.h>
#include <limits.h>
#include "conntrackd.h"
#include "bitops.h"
#include "cidr.h"
#include "helper.h"
#include "stack.h"
#include <sched.h>
#include <dlfcn.h>
#include <libnetfilter_conntrack/libnetfilter_conntrack.h>
#include <libnetfilter_conntrack/libnetfilter_conntrack_tcp.h>

extern char *yytext;
extern int   yylineno;

struct ct_conf conf;

static void __kernel_filter_start(void);
static void __kernel_filter_add_state(int value);
static void __max_dedicated_links_reached(void);

struct stack symbol_stack;

enum {
	SYMBOL_HELPER_QUEUE_NUM,
	SYMBOL_HELPER_QUEUE_LEN,
	SYMBOL_HELPER_POLICY_EXPECT_ROOT,
	SYMBOL_HELPER_EXPECT_POLICY_LEAF,
};


#line 129 "read_config_yy.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_READ_CONFIG_YY_H_INCLUDED
# define YY_YY_READ_CONFIG_YY_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    T_IPV4_ADDR = 258,             /* T_IPV4_ADDR  */
    T_IPV4_IFACE = 259,            /* T_IPV4_IFACE  */
    T_PORT = 260,                  /* T_PORT  */
    T_HASHSIZE = 261,              /* T_HASHSIZE  */
    T_HASHLIMIT = 262,             /* T_HASHLIMIT  */
    T_MULTICAST = 263,             /* T_MULTICAST  */
    T_PATH = 264,                  /* T_PATH  */
    T_UNIX = 265,                  /* T_UNIX  */
    T_REFRESH = 266,               /* T_REFRESH  */
    T_IPV6_ADDR = 267,             /* T_IPV6_ADDR  */
    T_IPV6_IFACE = 268,            /* T_IPV6_IFACE  */
    T_BACKLOG = 269,               /* T_BACKLOG  */
    T_GROUP = 270,                 /* T_GROUP  */
    T_IGNORE = 271,                /* T_IGNORE  */
    T_LOG = 272,                   /* T_LOG  */
    T_UDP = 273,                   /* T_UDP  */
    T_ICMP = 274,                  /* T_ICMP  */
    T_IGMP = 275,                  /* T_IGMP  */
    T_VRRP = 276,                  /* T_VRRP  */
    T_TCP = 277,                   /* T_TCP  */
    T_LOCK = 278,                  /* T_LOCK  */
    T_BUFFER_SIZE_MAX_GROWN = 279, /* T_BUFFER_SIZE_MAX_GROWN  */
    T_EXPIRE = 280,                /* T_EXPIRE  */
    T_TIMEOUT = 281,               /* T_TIMEOUT  */
    T_GENERAL = 282,               /* T_GENERAL  */
    T_SYNC = 283,                  /* T_SYNC  */
    T_STATS = 284,                 /* T_STATS  */
    T_BUFFER_SIZE = 285,           /* T_BUFFER_SIZE  */
    T_SYNC_MODE = 286,             /* T_SYNC_MODE  */
    T_ALARM = 287,                 /* T_ALARM  */
    T_FTFW = 288,                  /* T_FTFW  */
    T_CHECKSUM = 289,              /* T_CHECKSUM  */
    T_WINDOWSIZE = 290,            /* T_WINDOWSIZE  */
    T_ON = 291,                    /* T_ON  */
    T_OFF = 292,                   /* T_OFF  */
    T_FOR = 293,                   /* T_FOR  */
    T_IFACE = 294,                 /* T_IFACE  */
    T_PURGE = 295,                 /* T_PURGE  */
    T_RESEND_QUEUE_SIZE = 296,     /* T_RESEND_QUEUE_SIZE  */
    T_ESTABLISHED = 297,           /* T_ESTABLISHED  */
    T_SYN_SENT = 298,              /* T_SYN_SENT  */
    T_SYN_RECV = 299,              /* T_SYN_RECV  */
    T_FIN_WAIT = 300,              /* T_FIN_WAIT  */
    T_CLOSE_WAIT = 301,            /* T_CLOSE_WAIT  */
    T_LAST_ACK = 302,              /* T_LAST_ACK  */
    T_TIME_WAIT = 303,             /* T_TIME_WAIT  */
    T_CLOSE = 304,                 /* T_CLOSE  */
    T_LISTEN = 305,                /* T_LISTEN  */
    T_SYSLOG = 306,                /* T_SYSLOG  */
    T_RCVBUFF = 307,               /* T_RCVBUFF  */
    T_SNDBUFF = 308,               /* T_SNDBUFF  */
    T_NOTRACK = 309,               /* T_NOTRACK  */
    T_POLL_SECS = 310,             /* T_POLL_SECS  */
    T_FILTER = 311,                /* T_FILTER  */
    T_ADDRESS = 312,               /* T_ADDRESS  */
    T_PROTOCOL = 313,              /* T_PROTOCOL  */
    T_STATE = 314,                 /* T_STATE  */
    T_ACCEPT = 315,                /* T_ACCEPT  */
    T_FROM = 316,                  /* T_FROM  */
    T_USERSPACE = 317,             /* T_USERSPACE  */
    T_KERNELSPACE = 318,           /* T_KERNELSPACE  */
    T_EVENT_ITER_LIMIT = 319,      /* T_EVENT_ITER_LIMIT  */
    T_DEFAULT = 320,               /* T_DEFAULT  */
    T_NETLINK_OVERRUN_RESYNC = 321, /* T_NETLINK_OVERRUN_RESYNC  */
    T_NICE = 322,                  /* T_NICE  */
    T_IPV4_DEST_ADDR = 323,        /* T_IPV4_DEST_ADDR  */
    T_IPV6_DEST_ADDR = 324,        /* T_IPV6_DEST_ADDR  */
    T_SCHEDULER = 325,             /* T_SCHEDULER  */
    T_TYPE = 326,                  /* T_TYPE  */
    T_PRIO = 327,                  /* T_PRIO  */
    T_NETLINK_EVENTS_RELIABLE = 328, /* T_NETLINK_EVENTS_RELIABLE  */
    T_DISABLE_INTERNAL_CACHE = 329, /* T_DISABLE_INTERNAL_CACHE  */
    T_DISABLE_EXTERNAL_CACHE = 330, /* T_DISABLE_EXTERNAL_CACHE  */
    T_ERROR_QUEUE_LENGTH = 331,    /* T_ERROR_QUEUE_LENGTH  */
    T_OPTIONS = 332,               /* T_OPTIONS  */
    T_TCP_WINDOW_TRACKING = 333,   /* T_TCP_WINDOW_TRACKING  */
    T_EXPECT_SYNC = 334,           /* T_EXPECT_SYNC  */
    T_HELPER = 335,                /* T_HELPER  */
    T_HELPER_QUEUE_NUM = 336,      /* T_HELPER_QUEUE_NUM  */
    T_HELPER_QUEUE_LEN = 337,      /* T_HELPER_QUEUE_LEN  */
    T_HELPER_POLICY = 338,         /* T_HELPER_POLICY  */
    T_HELPER_EXPECT_TIMEOUT = 339, /* T_HELPER_EXPECT_TIMEOUT  */
    T_HELPER_EXPECT_MAX = 340,     /* T_HELPER_EXPECT_MAX  */
    T_SYSTEMD = 341,               /* T_SYSTEMD  */
    T_STARTUP_RESYNC = 342,        /* T_STARTUP_RESYNC  */
    T_IP = 343,                    /* T_IP  */
    T_PATH_VAL = 344,              /* T_PATH_VAL  */
    T_NUMBER = 345,                /* T_NUMBER  */
    T_SIGNED_NUMBER = 346,         /* T_SIGNED_NUMBER  */
    T_STRING = 347                 /* T_STRING  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define T_IPV4_ADDR 258
#define T_IPV4_IFACE 259
#define T_PORT 260
#define T_HASHSIZE 261
#define T_HASHLIMIT 262
#define T_MULTICAST 263
#define T_PATH 264
#define T_UNIX 265
#define T_REFRESH 266
#define T_IPV6_ADDR 267
#define T_IPV6_IFACE 268
#define T_BACKLOG 269
#define T_GROUP 270
#define T_IGNORE 271
#define T_LOG 272
#define T_UDP 273
#define T_ICMP 274
#define T_IGMP 275
#define T_VRRP 276
#define T_TCP 277
#define T_LOCK 278
#define T_BUFFER_SIZE_MAX_GROWN 279
#define T_EXPIRE 280
#define T_TIMEOUT 281
#define T_GENERAL 282
#define T_SYNC 283
#define T_STATS 284
#define T_BUFFER_SIZE 285
#define T_SYNC_MODE 286
#define T_ALARM 287
#define T_FTFW 288
#define T_CHECKSUM 289
#define T_WINDOWSIZE 290
#define T_ON 291
#define T_OFF 292
#define T_FOR 293
#define T_IFACE 294
#define T_PURGE 295
#define T_RESEND_QUEUE_SIZE 296
#define T_ESTABLISHED 297
#define T_SYN_SENT 298
#define T_SYN_RECV 299
#define T_FIN_WAIT 300
#define T_CLOSE_WAIT 301
#define T_LAST_ACK 302
#define T_TIME_WAIT 303
#define T_CLOSE 304
#define T_LISTEN 305
#define T_SYSLOG 306
#define T_RCVBUFF 307
#define T_SNDBUFF 308
#define T_NOTRACK 309
#define T_POLL_SECS 310
#define T_FILTER 311
#define T_ADDRESS 312
#define T_PROTOCOL 313
#define T_STATE 314
#define T_ACCEPT 315
#define T_FROM 316
#define T_USERSPACE 317
#define T_KERNELSPACE 318
#define T_EVENT_ITER_LIMIT 319
#define T_DEFAULT 320
#define T_NETLINK_OVERRUN_RESYNC 321
#define T_NICE 322
#define T_IPV4_DEST_ADDR 323
#define T_IPV6_DEST_ADDR 324
#define T_SCHEDULER 325
#define T_TYPE 326
#define T_PRIO 327
#define T_NETLINK_EVENTS_RELIABLE 328
#define T_DISABLE_INTERNAL_CACHE 329
#define T_DISABLE_EXTERNAL_CACHE 330
#define T_ERROR_QUEUE_LENGTH 331
#define T_OPTIONS 332
#define T_TCP_WINDOW_TRACKING 333
#define T_EXPECT_SYNC 334
#define T_HELPER 335
#define T_HELPER_QUEUE_NUM 336
#define T_HELPER_QUEUE_LEN 337
#define T_HELPER_POLICY 338
#define T_HELPER_EXPECT_TIMEOUT 339
#define T_HELPER_EXPECT_MAX 340
#define T_SYSTEMD 341
#define T_STARTUP_RESYNC 342
#define T_IP 343
#define T_PATH_VAL 344
#define T_NUMBER 345
#define T_SIGNED_NUMBER 346
#define T_STRING 347

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 59 "read_config_yy.y"

	int		val;
	char		*string;

#line 371 "read_config_yy.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_READ_CONFIG_YY_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_IPV4_ADDR = 3,                /* T_IPV4_ADDR  */
  YYSYMBOL_T_IPV4_IFACE = 4,               /* T_IPV4_IFACE  */
  YYSYMBOL_T_PORT = 5,                     /* T_PORT  */
  YYSYMBOL_T_HASHSIZE = 6,                 /* T_HASHSIZE  */
  YYSYMBOL_T_HASHLIMIT = 7,                /* T_HASHLIMIT  */
  YYSYMBOL_T_MULTICAST = 8,                /* T_MULTICAST  */
  YYSYMBOL_T_PATH = 9,                     /* T_PATH  */
  YYSYMBOL_T_UNIX = 10,                    /* T_UNIX  */
  YYSYMBOL_T_REFRESH = 11,                 /* T_REFRESH  */
  YYSYMBOL_T_IPV6_ADDR = 12,               /* T_IPV6_ADDR  */
  YYSYMBOL_T_IPV6_IFACE = 13,              /* T_IPV6_IFACE  */
  YYSYMBOL_T_BACKLOG = 14,                 /* T_BACKLOG  */
  YYSYMBOL_T_GROUP = 15,                   /* T_GROUP  */
  YYSYMBOL_T_IGNORE = 16,                  /* T_IGNORE  */
  YYSYMBOL_T_LOG = 17,                     /* T_LOG  */
  YYSYMBOL_T_UDP = 18,                     /* T_UDP  */
  YYSYMBOL_T_ICMP = 19,                    /* T_ICMP  */
  YYSYMBOL_T_IGMP = 20,                    /* T_IGMP  */
  YYSYMBOL_T_VRRP = 21,                    /* T_VRRP  */
  YYSYMBOL_T_TCP = 22,                     /* T_TCP  */
  YYSYMBOL_T_LOCK = 23,                    /* T_LOCK  */
  YYSYMBOL_T_BUFFER_SIZE_MAX_GROWN = 24,   /* T_BUFFER_SIZE_MAX_GROWN  */
  YYSYMBOL_T_EXPIRE = 25,                  /* T_EXPIRE  */
  YYSYMBOL_T_TIMEOUT = 26,                 /* T_TIMEOUT  */
  YYSYMBOL_T_GENERAL = 27,                 /* T_GENERAL  */
  YYSYMBOL_T_SYNC = 28,                    /* T_SYNC  */
  YYSYMBOL_T_STATS = 29,                   /* T_STATS  */
  YYSYMBOL_T_BUFFER_SIZE = 30,             /* T_BUFFER_SIZE  */
  YYSYMBOL_T_SYNC_MODE = 31,               /* T_SYNC_MODE  */
  YYSYMBOL_T_ALARM = 32,                   /* T_ALARM  */
  YYSYMBOL_T_FTFW = 33,                    /* T_FTFW  */
  YYSYMBOL_T_CHECKSUM = 34,                /* T_CHECKSUM  */
  YYSYMBOL_T_WINDOWSIZE = 35,              /* T_WINDOWSIZE  */
  YYSYMBOL_T_ON = 36,                      /* T_ON  */
  YYSYMBOL_T_OFF = 37,                     /* T_OFF  */
  YYSYMBOL_T_FOR = 38,                     /* T_FOR  */
  YYSYMBOL_T_IFACE = 39,                   /* T_IFACE  */
  YYSYMBOL_T_PURGE = 40,                   /* T_PURGE  */
  YYSYMBOL_T_RESEND_QUEUE_SIZE = 41,       /* T_RESEND_QUEUE_SIZE  */
  YYSYMBOL_T_ESTABLISHED = 42,             /* T_ESTABLISHED  */
  YYSYMBOL_T_SYN_SENT = 43,                /* T_SYN_SENT  */
  YYSYMBOL_T_SYN_RECV = 44,                /* T_SYN_RECV  */
  YYSYMBOL_T_FIN_WAIT = 45,                /* T_FIN_WAIT  */
  YYSYMBOL_T_CLOSE_WAIT = 46,              /* T_CLOSE_WAIT  */
  YYSYMBOL_T_LAST_ACK = 47,                /* T_LAST_ACK  */
  YYSYMBOL_T_TIME_WAIT = 48,               /* T_TIME_WAIT  */
  YYSYMBOL_T_CLOSE = 49,                   /* T_CLOSE  */
  YYSYMBOL_T_LISTEN = 50,                  /* T_LISTEN  */
  YYSYMBOL_T_SYSLOG = 51,                  /* T_SYSLOG  */
  YYSYMBOL_T_RCVBUFF = 52,                 /* T_RCVBUFF  */
  YYSYMBOL_T_SNDBUFF = 53,                 /* T_SNDBUFF  */
  YYSYMBOL_T_NOTRACK = 54,                 /* T_NOTRACK  */
  YYSYMBOL_T_POLL_SECS = 55,               /* T_POLL_SECS  */
  YYSYMBOL_T_FILTER = 56,                  /* T_FILTER  */
  YYSYMBOL_T_ADDRESS = 57,                 /* T_ADDRESS  */
  YYSYMBOL_T_PROTOCOL = 58,                /* T_PROTOCOL  */
  YYSYMBOL_T_STATE = 59,                   /* T_STATE  */
  YYSYMBOL_T_ACCEPT = 60,                  /* T_ACCEPT  */
  YYSYMBOL_T_FROM = 61,                    /* T_FROM  */
  YYSYMBOL_T_USERSPACE = 62,               /* T_USERSPACE  */
  YYSYMBOL_T_KERNELSPACE = 63,             /* T_KERNELSPACE  */
  YYSYMBOL_T_EVENT_ITER_LIMIT = 64,        /* T_EVENT_ITER_LIMIT  */
  YYSYMBOL_T_DEFAULT = 65,                 /* T_DEFAULT  */
  YYSYMBOL_T_NETLINK_OVERRUN_RESYNC = 66,  /* T_NETLINK_OVERRUN_RESYNC  */
  YYSYMBOL_T_NICE = 67,                    /* T_NICE  */
  YYSYMBOL_T_IPV4_DEST_ADDR = 68,          /* T_IPV4_DEST_ADDR  */
  YYSYMBOL_T_IPV6_DEST_ADDR = 69,          /* T_IPV6_DEST_ADDR  */
  YYSYMBOL_T_SCHEDULER = 70,               /* T_SCHEDULER  */
  YYSYMBOL_T_TYPE = 71,                    /* T_TYPE  */
  YYSYMBOL_T_PRIO = 72,                    /* T_PRIO  */
  YYSYMBOL_T_NETLINK_EVENTS_RELIABLE = 73, /* T_NETLINK_EVENTS_RELIABLE  */
  YYSYMBOL_T_DISABLE_INTERNAL_CACHE = 74,  /* T_DISABLE_INTERNAL_CACHE  */
  YYSYMBOL_T_DISABLE_EXTERNAL_CACHE = 75,  /* T_DISABLE_EXTERNAL_CACHE  */
  YYSYMBOL_T_ERROR_QUEUE_LENGTH = 76,      /* T_ERROR_QUEUE_LENGTH  */
  YYSYMBOL_T_OPTIONS = 77,                 /* T_OPTIONS  */
  YYSYMBOL_T_TCP_WINDOW_TRACKING = 78,     /* T_TCP_WINDOW_TRACKING  */
  YYSYMBOL_T_EXPECT_SYNC = 79,             /* T_EXPECT_SYNC  */
  YYSYMBOL_T_HELPER = 80,                  /* T_HELPER  */
  YYSYMBOL_T_HELPER_QUEUE_NUM = 81,        /* T_HELPER_QUEUE_NUM  */
  YYSYMBOL_T_HELPER_QUEUE_LEN = 82,        /* T_HELPER_QUEUE_LEN  */
  YYSYMBOL_T_HELPER_POLICY = 83,           /* T_HELPER_POLICY  */
  YYSYMBOL_T_HELPER_EXPECT_TIMEOUT = 84,   /* T_HELPER_EXPECT_TIMEOUT  */
  YYSYMBOL_T_HELPER_EXPECT_MAX = 85,       /* T_HELPER_EXPECT_MAX  */
  YYSYMBOL_T_SYSTEMD = 86,                 /* T_SYSTEMD  */
  YYSYMBOL_T_STARTUP_RESYNC = 87,          /* T_STARTUP_RESYNC  */
  YYSYMBOL_T_IP = 88,                      /* T_IP  */
  YYSYMBOL_T_PATH_VAL = 89,                /* T_PATH_VAL  */
  YYSYMBOL_T_NUMBER = 90,                  /* T_NUMBER  */
  YYSYMBOL_T_SIGNED_NUMBER = 91,           /* T_SIGNED_NUMBER  */
  YYSYMBOL_T_STRING = 92,                  /* T_STRING  */
  YYSYMBOL_93_ = 93,                       /* '{'  */
  YYSYMBOL_94_ = 94,                       /* '}'  */
  YYSYMBOL_YYACCEPT = 95,                  /* $accept  */
  YYSYMBOL_configfile = 96,                /* configfile  */
  YYSYMBOL_lines = 97,                     /* lines  */
  YYSYMBOL_line = 98,                      /* line  */
  YYSYMBOL_logfile_bool = 99,              /* logfile_bool  */
  YYSYMBOL_logfile_path = 100,             /* logfile_path  */
  YYSYMBOL_syslog_bool = 101,              /* syslog_bool  */
  YYSYMBOL_syslog_facility = 102,          /* syslog_facility  */
  YYSYMBOL_lock = 103,                     /* lock  */
  YYSYMBOL_refreshtime = 104,              /* refreshtime  */
  YYSYMBOL_expiretime = 105,               /* expiretime  */
  YYSYMBOL_timeout = 106,                  /* timeout  */
  YYSYMBOL_purge = 107,                    /* purge  */
  YYSYMBOL_multicast_line = 108,           /* multicast_line  */
  YYSYMBOL_multicast_options = 109,        /* multicast_options  */
  YYSYMBOL_multicast_option = 110,         /* multicast_option  */
  YYSYMBOL_udp_line = 111,                 /* udp_line  */
  YYSYMBOL_udp_options = 112,              /* udp_options  */
  YYSYMBOL_udp_option = 113,               /* udp_option  */
  YYSYMBOL_tcp_line = 114,                 /* tcp_line  */
  YYSYMBOL_tcp_options = 115,              /* tcp_options  */
  YYSYMBOL_tcp_option = 116,               /* tcp_option  */
  YYSYMBOL_hashsize = 117,                 /* hashsize  */
  YYSYMBOL_hashlimit = 118,                /* hashlimit  */
  YYSYMBOL_unix_line = 119,                /* unix_line  */
  YYSYMBOL_unix_options = 120,             /* unix_options  */
  YYSYMBOL_unix_option = 121,              /* unix_option  */
  YYSYMBOL_sync = 122,                     /* sync  */
  YYSYMBOL_sync_list = 123,                /* sync_list  */
  YYSYMBOL_sync_line = 124,                /* sync_line  */
  YYSYMBOL_option_line = 125,              /* option_line  */
  YYSYMBOL_options = 126,                  /* options  */
  YYSYMBOL_option = 127,                   /* option  */
  YYSYMBOL_expect_list = 128,              /* expect_list  */
  YYSYMBOL_expect_item = 129,              /* expect_item  */
  YYSYMBOL_sync_mode_alarm = 130,          /* sync_mode_alarm  */
  YYSYMBOL_sync_mode_ftfw = 131,           /* sync_mode_ftfw  */
  YYSYMBOL_sync_mode_notrack = 132,        /* sync_mode_notrack  */
  YYSYMBOL_sync_mode_alarm_list = 133,     /* sync_mode_alarm_list  */
  YYSYMBOL_sync_mode_alarm_line = 134,     /* sync_mode_alarm_line  */
  YYSYMBOL_sync_mode_ftfw_list = 135,      /* sync_mode_ftfw_list  */
  YYSYMBOL_sync_mode_ftfw_line = 136,      /* sync_mode_ftfw_line  */
  YYSYMBOL_sync_mode_notrack_list = 137,   /* sync_mode_notrack_list  */
  YYSYMBOL_sync_mode_notrack_line = 138,   /* sync_mode_notrack_line  */
  YYSYMBOL_disable_internal_cache = 139,   /* disable_internal_cache  */
  YYSYMBOL_disable_external_cache = 140,   /* disable_external_cache  */
  YYSYMBOL_resend_queue_size = 141,        /* resend_queue_size  */
  YYSYMBOL_startup_resync = 142,           /* startup_resync  */
  YYSYMBOL_window_size = 143,              /* window_size  */
  YYSYMBOL_tcp_states = 144,               /* tcp_states  */
  YYSYMBOL_tcp_state = 145,                /* tcp_state  */
  YYSYMBOL_general = 146,                  /* general  */
  YYSYMBOL_general_list = 147,             /* general_list  */
  YYSYMBOL_general_line = 148,             /* general_line  */
  YYSYMBOL_systemd = 149,                  /* systemd  */
  YYSYMBOL_netlink_buffer_size = 150,      /* netlink_buffer_size  */
  YYSYMBOL_netlink_buffer_size_max_grown = 151, /* netlink_buffer_size_max_grown  */
  YYSYMBOL_netlink_overrun_resync = 152,   /* netlink_overrun_resync  */
  YYSYMBOL_netlink_events_reliable = 153,  /* netlink_events_reliable  */
  YYSYMBOL_nice = 154,                     /* nice  */
  YYSYMBOL_scheduler = 155,                /* scheduler  */
  YYSYMBOL_scheduler_options = 156,        /* scheduler_options  */
  YYSYMBOL_scheduler_line = 157,           /* scheduler_line  */
  YYSYMBOL_event_iterations_limit = 158,   /* event_iterations_limit  */
  YYSYMBOL_poll_secs = 159,                /* poll_secs  */
  YYSYMBOL_filter = 160,                   /* filter  */
  YYSYMBOL_filter_list = 161,              /* filter_list  */
  YYSYMBOL_filter_item = 162,              /* filter_item  */
  YYSYMBOL_filter_protocol_list = 163,     /* filter_protocol_list  */
  YYSYMBOL_filter_protocol_item = 164,     /* filter_protocol_item  */
  YYSYMBOL_filter_address_list = 165,      /* filter_address_list  */
  YYSYMBOL_filter_address_item = 166,      /* filter_address_item  */
  YYSYMBOL_filter_state_list = 167,        /* filter_state_list  */
  YYSYMBOL_filter_state_item = 168,        /* filter_state_item  */
  YYSYMBOL_stats = 169,                    /* stats  */
  YYSYMBOL_stats_list = 170,               /* stats_list  */
  YYSYMBOL_stat_line = 171,                /* stat_line  */
  YYSYMBOL_stat_logfile_bool = 172,        /* stat_logfile_bool  */
  YYSYMBOL_stat_logfile_path = 173,        /* stat_logfile_path  */
  YYSYMBOL_stat_syslog_bool = 174,         /* stat_syslog_bool  */
  YYSYMBOL_stat_syslog_facility = 175,     /* stat_syslog_facility  */
  YYSYMBOL_helper = 176,                   /* helper  */
  YYSYMBOL_helper_list = 177,              /* helper_list  */
  YYSYMBOL_helper_line = 178,              /* helper_line  */
  YYSYMBOL_helper_type = 179,              /* helper_type  */
  YYSYMBOL_helper_type_list = 180,         /* helper_type_list  */
  YYSYMBOL_helper_type_line = 181,         /* helper_type_line  */
  YYSYMBOL_helper_policy_list = 182,       /* helper_policy_list  */
  YYSYMBOL_helper_policy_line = 183,       /* helper_policy_line  */
  YYSYMBOL_helper_policy_expect_max = 184, /* helper_policy_expect_max  */
  YYSYMBOL_helper_policy_expect_timeout = 185 /* helper_policy_expect_timeout  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  16
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   331

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  95
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  91
/* YYNRULES -- Number of rules.  */
#define YYNRULES  229
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  367

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   347


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    93,     2,    94,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    94,    94,    95,    98,    99,   102,   103,   104,   105,
     108,   113,   117,   128,   133,   138,   172,   183,   188,   193,
     198,   203,   217,   233,   234,   236,   257,   300,   321,   327,
     350,   356,   362,   368,   374,   380,   394,   410,   411,   413,
     426,   446,   459,   479,   497,   503,   509,   515,   521,   527,
     543,   561,   562,   564,   577,   597,   610,   630,   648,   654,
     660,   666,   672,   678,   684,   689,   694,   696,   697,   700,
     711,   716,   726,   727,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   742,   744,   745,   748,   753,
     758,   770,   778,   790,   791,   793,   799,   804,   809,   814,
     815,   817,   818,   819,   820,   823,   824,   826,   827,   828,
     829,   830,   831,   834,   835,   837,   838,   839,   840,   841,
     844,   849,   854,   859,   864,   869,   874,   879,   884,   885,
     887,   895,   903,   911,   919,   927,   935,   943,   951,   960,
     962,   963,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,   976,   977,   978,   979,   980,   981,   982,   983,
     986,   987,   989,   994,   999,  1004,  1009,  1014,  1019,  1024,
    1030,  1032,  1033,  1036,  1051,  1060,  1065,  1075,  1080,  1085,
    1090,  1091,  1093,  1102,  1115,  1116,  1118,  1139,  1158,  1177,
    1186,  1208,  1209,  1211,  1272,  1335,  1344,  1358,  1359,  1361,
    1363,  1373,  1374,  1377,  1378,  1379,  1380,  1383,  1388,  1392,
    1403,  1408,  1413,  1447,  1452,  1453,  1456,  1459,  1565,  1566,
    1569,  1572,  1583,  1594,  1621,  1622,  1625,  1626,  1629,  1644
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_IPV4_ADDR",
  "T_IPV4_IFACE", "T_PORT", "T_HASHSIZE", "T_HASHLIMIT", "T_MULTICAST",
  "T_PATH", "T_UNIX", "T_REFRESH", "T_IPV6_ADDR", "T_IPV6_IFACE",
  "T_BACKLOG", "T_GROUP", "T_IGNORE", "T_LOG", "T_UDP", "T_ICMP", "T_IGMP",
  "T_VRRP", "T_TCP", "T_LOCK", "T_BUFFER_SIZE_MAX_GROWN", "T_EXPIRE",
  "T_TIMEOUT", "T_GENERAL", "T_SYNC", "T_STATS", "T_BUFFER_SIZE",
  "T_SYNC_MODE", "T_ALARM", "T_FTFW", "T_CHECKSUM", "T_WINDOWSIZE", "T_ON",
  "T_OFF", "T_FOR", "T_IFACE", "T_PURGE", "T_RESEND_QUEUE_SIZE",
  "T_ESTABLISHED", "T_SYN_SENT", "T_SYN_RECV", "T_FIN_WAIT",
  "T_CLOSE_WAIT", "T_LAST_ACK", "T_TIME_WAIT", "T_CLOSE", "T_LISTEN",
  "T_SYSLOG", "T_RCVBUFF", "T_SNDBUFF", "T_NOTRACK", "T_POLL_SECS",
  "T_FILTER", "T_ADDRESS", "T_PROTOCOL", "T_STATE", "T_ACCEPT", "T_FROM",
  "T_USERSPACE", "T_KERNELSPACE", "T_EVENT_ITER_LIMIT", "T_DEFAULT",
  "T_NETLINK_OVERRUN_RESYNC", "T_NICE", "T_IPV4_DEST_ADDR",
  "T_IPV6_DEST_ADDR", "T_SCHEDULER", "T_TYPE", "T_PRIO",
  "T_NETLINK_EVENTS_RELIABLE", "T_DISABLE_INTERNAL_CACHE",
  "T_DISABLE_EXTERNAL_CACHE", "T_ERROR_QUEUE_LENGTH", "T_OPTIONS",
  "T_TCP_WINDOW_TRACKING", "T_EXPECT_SYNC", "T_HELPER",
  "T_HELPER_QUEUE_NUM", "T_HELPER_QUEUE_LEN", "T_HELPER_POLICY",
  "T_HELPER_EXPECT_TIMEOUT", "T_HELPER_EXPECT_MAX", "T_SYSTEMD",
  "T_STARTUP_RESYNC", "T_IP", "T_PATH_VAL", "T_NUMBER", "T_SIGNED_NUMBER",
  "T_STRING", "'{'", "'}'", "$accept", "configfile", "lines", "line",
  "logfile_bool", "logfile_path", "syslog_bool", "syslog_facility", "lock",
  "refreshtime", "expiretime", "timeout", "purge", "multicast_line",
  "multicast_options", "multicast_option", "udp_line", "udp_options",
  "udp_option", "tcp_line", "tcp_options", "tcp_option", "hashsize",
  "hashlimit", "unix_line", "unix_options", "unix_option", "sync",
  "sync_list", "sync_line", "option_line", "options", "option",
  "expect_list", "expect_item", "sync_mode_alarm", "sync_mode_ftfw",
  "sync_mode_notrack", "sync_mode_alarm_list", "sync_mode_alarm_line",
  "sync_mode_ftfw_list", "sync_mode_ftfw_line", "sync_mode_notrack_list",
  "sync_mode_notrack_line", "disable_internal_cache",
  "disable_external_cache", "resend_queue_size", "startup_resync",
  "window_size", "tcp_states", "tcp_state", "general", "general_list",
  "general_line", "systemd", "netlink_buffer_size",
  "netlink_buffer_size_max_grown", "netlink_overrun_resync",
  "netlink_events_reliable", "nice", "scheduler", "scheduler_options",
  "scheduler_line", "event_iterations_limit", "poll_secs", "filter",
  "filter_list", "filter_item", "filter_protocol_list",
  "filter_protocol_item", "filter_address_list", "filter_address_item",
  "filter_state_list", "filter_state_item", "stats", "stats_list",
  "stat_line", "stat_logfile_bool", "stat_logfile_path",
  "stat_syslog_bool", "stat_syslog_facility", "helper", "helper_list",
  "helper_line", "helper_type", "helper_type_list", "helper_type_line",
  "helper_policy_list", "helper_policy_line", "helper_policy_expect_max",
  "helper_policy_expect_timeout", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   123,   125
};
#endif

#define YYPACT_NINF (-73)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      91,   -72,   -66,   -63,   -60,    38,    91,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   100,   118,
       6,   120,   -47,   -42,   -39,    53,   -38,   -20,    -4,    43,
      25,   -26,    35,    51,    68,    41,   174,   186,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -18,    64,
      20,    97,    71,    75,   172,    78,    79,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
      96,    47,   -73,   -73,   -73,   -73,   -73,   -73,     4,    94,
     103,   108,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   187,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     132,   -73,   -73,   139,   -73,   155,   -73,   -73,   -73,   175,
     176,   177,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     135,   -73,   -73,   178,    15,   179,   180,   119,   126,   -73,
       3,   -73,    59,   -73,    -3,   -73,   -73,   -73,   137,   138,
     -73,   128,   184,   -73,   -73,   -73,   -73,   -15,    -2,    45,
     -73,   -73,   173,   185,   -73,   -73,     7,   188,   189,   190,
     192,   193,   215,   194,   195,   197,   -73,   -73,    69,   196,
     198,   201,   217,   199,   200,   202,   205,   206,   -73,   -73,
       0,   207,   208,   209,   219,   204,   210,   211,   214,   216,
     213,   -73,   -73,    52,   134,   105,   221,   -11,   -73,   -73,
     212,    63,   -73,   -73,   124,   130,   218,   220,   222,   224,
     226,   228,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   230,   232,   223,   225,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   227,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     233,   234,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     -73,   -73,    58,   125,   -73,   -73,     1,     5,    10,    22,
     231,   235,   -73,   -73,   -73,   -73,   -73,   -73,   238,   239,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     191,   -73,   -73,   -73,   -73,   257,   -73,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     0,     0,     0,     0,     3,     4,     7,     6,
       8,     9,   140,    72,   201,   214,     1,     5,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   139,   144,
     145,   147,   146,   148,   142,   143,   149,   141,   159,   150,
     151,   155,   156,   157,   158,   152,   153,   154,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    71,    74,    75,
      76,    77,    78,    79,    80,    73,    84,    81,    82,    83,
       0,     0,   200,   202,   203,   204,   205,   206,     0,     0,
       0,     0,   213,   215,   216,    64,    65,    67,    10,    11,
      12,    16,   163,   162,    13,    14,    15,   176,     0,   180,
     175,   164,   165,   166,   169,   171,   167,   168,   160,   161,
       0,    23,    17,     0,    37,     0,    51,    18,    19,     0,
       0,     0,    20,    86,   207,   208,   209,   210,   211,   212,
       0,   221,   222,     0,     0,     0,     0,     0,     0,    23,
       0,    37,     0,    51,     0,    99,   105,   113,     0,     0,
     224,     0,     0,    66,    68,   180,   180,     0,     0,     0,
     177,   181,     0,     0,   170,   172,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    21,    24,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    38,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    49,    52,     0,     0,     0,     0,     0,    85,    87,
       0,     0,    69,    70,     0,     0,     0,     0,     0,     0,
       0,     0,   173,   174,    22,    25,    27,    26,    28,    30,
      33,    34,    29,    32,    31,    36,    39,    44,    40,    47,
      48,    43,    46,    45,    41,    42,    50,    53,    58,    54,
      61,    62,    57,    60,    59,    55,    56,    63,    96,   101,
     102,   103,   104,   100,     0,     0,     0,     0,    97,   108,
     109,   106,   111,   107,   112,   110,     0,    98,   115,   116,
     114,   117,   118,   119,    88,    89,    90,    91,    93,   218,
       0,     0,   223,   225,   226,   227,   178,   179,   191,   191,
     184,   184,   197,   197,   127,   124,   122,   123,   125,   126,
     120,   121,     0,     0,   229,   228,     0,     0,     0,     0,
     128,   128,    95,    92,    94,   217,   220,   219,     0,     0,
     190,   192,   189,   188,   187,   186,   183,   185,   182,   196,
       0,   198,   195,   193,   194,     0,   132,   130,   131,   133,
     134,   135,   136,   137,   138,   129,   199
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -73,   -73,   -73,   275,   -73,   -73,   -73,   -73,   -73,    86,
      93,    29,    32,   -73,   133,   -73,   -73,   156,   -73,   -73,
     157,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,    99,   -73,   113,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   101,   -73,    19,   -73,
      -1,   -73,    18,   -73,   -73,   -73,   -73,   -73,   -73,   -73,
     -73,   -73,   -73,   -73,   -14,   -73,   -73,   -73,   -73,   -73,
     -73
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     5,     6,     7,    39,    40,    41,    42,    43,    68,
      69,    70,    71,    72,   150,   187,    73,   152,   199,    74,
     154,   212,    44,    45,    46,   144,   164,     8,    19,    75,
      76,   158,   219,   322,   334,    77,    78,    79,   213,   273,
     214,   281,   215,   290,   291,   282,   283,   284,   285,   350,
     365,     9,    18,    47,    48,    49,    50,    51,    52,    53,
      54,   148,   175,    55,    56,    57,   147,   171,   328,   347,
     326,   341,   330,   351,    10,    20,    83,    84,    85,    86,
      87,    11,    21,    93,    94,   323,   337,   221,   303,   304,
     305
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     201,   226,   202,   201,   338,   202,   177,   178,   338,   203,
     177,   178,   203,   339,   228,   179,   180,   339,   181,   179,
     180,    12,   181,    80,   161,   296,   297,    13,   343,   162,
      14,   204,   344,    15,   204,   108,   205,   182,    16,   205,
     343,   182,   183,    95,   344,   227,   183,   120,    96,   206,
     207,   101,   206,   207,    97,   184,   185,    81,   229,   184,
     185,   230,   189,    59,   190,   208,   209,   109,   208,   209,
     102,   191,   189,   210,   190,   121,   210,    62,    63,   104,
     105,   191,   298,   137,   138,   123,   103,   111,   112,    98,
      99,   211,    65,   192,   256,   340,   140,   186,   193,   342,
      82,   234,   345,   192,   346,   231,    22,    23,   193,   163,
      24,   194,   195,   124,   345,   107,   348,    25,     1,     2,
       3,   194,   195,    26,    27,   110,    58,   196,   197,    59,
      28,    63,   134,   135,   115,   106,    60,   196,   197,   139,
      61,   113,   100,    62,    63,    65,   268,   300,   301,    64,
     332,    29,   333,   198,   122,    30,    31,   302,    65,   114,
      63,   127,   125,   245,    32,   128,    33,    34,   132,   274,
      35,     4,   133,    36,    65,   275,   167,   168,   169,   286,
     276,   167,   168,   169,   141,   136,    37,   167,   168,   169,
     126,    88,   277,   142,    38,    66,    88,   172,   173,   287,
     143,    89,    90,    91,   129,   130,    89,    90,    91,   276,
     116,   117,    67,   170,    92,   216,   217,   222,   306,   335,
     174,   277,   118,   119,   307,   149,   131,   159,   278,   355,
     220,   218,   151,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   271,   279,   288,   272,   280,   289,   153,   145,
     146,   240,   241,   249,   250,   260,   261,   294,   295,   316,
     317,   318,   319,   320,   321,   232,   224,   225,   155,   156,
     157,   160,   165,   166,   223,   233,   235,   236,   237,   366,
     238,    17,   176,   239,   246,   243,   242,   244,   247,   248,
     252,   251,   253,   254,   255,   257,   262,   259,   258,   269,
     263,   264,   265,   267,   266,   299,   270,   188,   327,   336,
     200,   308,     0,   309,   292,   310,     0,   311,     0,   312,
     314,   313,   315,   324,   325,   349,   353,   354,   293,   352,
     329,   331
};

static const yytype_int16 yycheck[] =
{
       3,    16,     5,     3,     3,     5,     3,     4,     3,    12,
       3,     4,    12,    12,    16,    12,    13,    12,    15,    12,
      13,    93,    15,    17,     9,    36,    37,    93,    18,    14,
      93,    34,    22,    93,    34,    61,    39,    34,     0,    39,
      18,    34,    39,    90,    22,    60,    39,    65,    90,    52,
      53,    89,    52,    53,    93,    52,    53,    51,    60,    52,
      53,    16,     3,    11,     5,    68,    69,    93,    68,    69,
      90,    12,     3,    76,     5,    93,    76,    25,    26,    36,
      37,    12,    93,    36,    37,    65,    90,    36,    37,    36,
      37,    94,    40,    34,    94,    94,    92,    94,    39,    94,
      94,    94,    92,    34,    94,    60,     6,     7,    39,    94,
      10,    52,    53,    93,    92,    90,    94,    17,    27,    28,
      29,    52,    53,    23,    24,    90,     8,    68,    69,    11,
      30,    26,    36,    37,    93,    92,    18,    68,    69,    92,
      22,    90,    89,    25,    26,    40,    94,    84,    85,    31,
      92,    51,    94,    94,    90,    55,    56,    94,    40,    91,
      26,    90,    65,    94,    64,    90,    66,    67,    90,    35,
      70,    80,    93,    73,    40,    41,    57,    58,    59,    74,
      75,    57,    58,    59,    90,    89,    86,    57,    58,    59,
      93,    71,    87,    90,    94,    77,    71,    71,    72,    94,
      92,    81,    82,    83,    32,    33,    81,    82,    83,    75,
      36,    37,    94,    94,    94,    78,    79,    89,    94,    94,
      94,    87,    36,    37,    94,    93,    54,    92,    94,    38,
      92,    94,    93,    42,    43,    44,    45,    46,    47,    48,
      49,    50,   213,   214,   215,   213,   214,   215,    93,    62,
      63,    36,    37,    36,    37,    36,    37,    36,    37,    36,
      37,    36,    37,    36,    37,    92,   165,   166,    93,    93,
      93,    93,    93,    93,    90,    90,    88,    88,    88,    22,
      88,     6,   149,    90,    88,    90,    92,    90,    90,    88,
      90,    92,    90,    88,    88,    88,    92,    88,    90,   213,
      90,    90,    88,    90,    88,    93,   213,   151,   309,   323,
     153,    93,    -1,    93,   215,    93,    -1,    93,    -1,    93,
      90,    93,    90,    90,    90,    94,    88,    88,   215,    94,
     311,   313
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    27,    28,    29,    80,    96,    97,    98,   122,   146,
     169,   176,    93,    93,    93,    93,     0,    98,   147,   123,
     170,   177,     6,     7,    10,    17,    23,    24,    30,    51,
      55,    56,    64,    66,    67,    70,    73,    86,    94,    99,
     100,   101,   102,   103,   117,   118,   119,   148,   149,   150,
     151,   152,   153,   154,   155,   158,   159,   160,     8,    11,
      18,    22,    25,    26,    31,    40,    77,    94,   104,   105,
     106,   107,   108,   111,   114,   124,   125,   130,   131,   132,
      17,    51,    94,   171,   172,   173,   174,   175,    71,    81,
      82,    83,    94,   178,   179,    90,    90,    93,    36,    37,
      89,    89,    90,    90,    36,    37,    92,    90,    61,    93,
      90,    36,    37,    90,    91,    93,    36,    37,    36,    37,
      65,    93,    90,    65,    93,    65,    93,    90,    90,    32,
      33,    54,    90,    93,    36,    37,    89,    36,    37,    92,
      92,    90,    90,    92,   120,    62,    63,   161,   156,    93,
     109,    93,   112,    93,   115,    93,    93,    93,   126,    92,
      93,     9,    14,    94,   121,    93,    93,    57,    58,    59,
      94,   162,    71,    72,    94,   157,   109,     3,     4,    12,
      13,    15,    34,    39,    52,    53,    94,   110,   112,     3,
       5,    12,    34,    39,    52,    53,    68,    69,    94,   113,
     115,     3,     5,    12,    34,    39,    52,    53,    68,    69,
      76,    94,   116,   133,   135,   137,    78,    79,    94,   127,
      92,   182,    89,    90,   161,   161,    16,    60,    16,    60,
      16,    60,    92,    90,    94,    88,    88,    88,    88,    90,
      36,    37,    92,    90,    90,    94,    88,    90,    88,    36,
      37,    92,    90,    90,    88,    88,    94,    88,    90,    88,
      36,    37,    92,    90,    90,    88,    88,    90,    94,   104,
     105,   106,   107,   134,    35,    41,    75,    87,    94,   106,
     107,   136,   140,   141,   142,   143,    74,    94,   106,   107,
     138,   139,   140,   142,    36,    37,    36,    37,    93,    93,
      84,    85,    94,   183,   184,   185,    94,    94,    93,    93,
      93,    93,    93,    93,    90,    90,    36,    37,    36,    37,
      36,    37,   128,   180,    90,    90,   165,   165,   163,   163,
     167,   167,    92,    94,   129,    94,   179,   181,     3,    12,
      94,   166,    94,    18,    22,    92,    94,   164,    94,    94,
     144,   168,    94,    88,    88,    38,    42,    43,    44,    45,
      46,    47,    48,    49,    50,   145,    22
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    95,    96,    96,    97,    97,    98,    98,    98,    98,
      99,    99,   100,   101,   101,   102,   103,   104,   105,   106,
     107,   108,   108,   109,   109,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   111,   111,   112,   112,   113,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   114,
     114,   115,   115,   116,   116,   116,   116,   116,   116,   116,
     116,   116,   116,   116,   117,   118,   119,   120,   120,   121,
     121,   122,   123,   123,   124,   124,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   125,   126,   126,   127,   127,
     127,   127,   127,   128,   128,   129,   130,   131,   132,   133,
     133,   134,   134,   134,   134,   135,   135,   136,   136,   136,
     136,   136,   136,   137,   137,   138,   138,   138,   138,   138,
     139,   139,   140,   140,   141,   142,   142,   143,   144,   144,
     145,   145,   145,   145,   145,   145,   145,   145,   145,   146,
     147,   147,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     149,   149,   150,   151,   152,   152,   152,   153,   153,   154,
     155,   156,   156,   157,   157,   158,   159,   160,   160,   160,
     161,   161,   162,   162,   163,   163,   164,   164,   164,   162,
     162,   165,   165,   166,   166,   162,   162,   167,   167,   168,
     169,   170,   170,   171,   171,   171,   171,   172,   172,   173,
     174,   174,   175,   176,   177,   177,   178,   179,   180,   180,
     181,   179,   179,   179,   182,   182,   183,   183,   184,   185
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     4,     5,     0,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     4,     5,     0,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     4,
       5,     0,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     4,     0,     2,     2,
       2,     4,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     0,     2,     2,     2,
       2,     2,     4,     0,     2,     1,     5,     5,     5,     0,
       2,     1,     1,     1,     1,     0,     2,     1,     1,     1,
       1,     1,     1,     0,     2,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     0,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       4,     0,     2,     2,     2,     2,     2,     4,     6,     6,
       0,     2,     5,     5,     0,     2,     1,     1,     1,     5,
       5,     0,     2,     2,     2,     5,     5,     0,     2,     3,
       4,     0,     2,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     2,     4,     0,     2,     1,     7,     0,     2,
       1,     2,     2,     5,     0,     2,     1,     1,     2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 10: /* logfile_bool: T_LOG T_ON  */
#line 109 "read_config_yy.y"
{
	strncpy(conf.logfile, DEFAULT_LOGFILE, FILENAME_MAXLEN);
}
#line 1836 "read_config_yy.c"
    break;

  case 11: /* logfile_bool: T_LOG T_OFF  */
#line 114 "read_config_yy.y"
{
}
#line 1843 "read_config_yy.c"
    break;

  case 12: /* logfile_path: T_LOG T_PATH_VAL  */
#line 118 "read_config_yy.y"
{
	if (strlen((yyvsp[0].string)) > FILENAME_MAXLEN) {
		dlog(LOG_ERR, "LogFile path is longer than %u characters",
		     FILENAME_MAXLEN);
		exit(EXIT_FAILURE);
	}
	snprintf(conf.logfile, sizeof(conf.logfile), "%s", (yyvsp[0].string));
	free((yyvsp[0].string));
}
#line 1857 "read_config_yy.c"
    break;

  case 13: /* syslog_bool: T_SYSLOG T_ON  */
#line 129 "read_config_yy.y"
{
	conf.syslog_facility = DEFAULT_SYSLOG_FACILITY;
}
#line 1865 "read_config_yy.c"
    break;

  case 14: /* syslog_bool: T_SYSLOG T_OFF  */
#line 134 "read_config_yy.y"
{
	conf.syslog_facility = -1;
}
#line 1873 "read_config_yy.c"
    break;

  case 15: /* syslog_facility: T_SYSLOG T_STRING  */
#line 139 "read_config_yy.y"
{
	if (!strcmp((yyvsp[0].string), "daemon"))
		conf.syslog_facility = LOG_DAEMON;
	else if (!strcmp((yyvsp[0].string), "local0"))
		conf.syslog_facility = LOG_LOCAL0;
	else if (!strcmp((yyvsp[0].string), "local1"))
		conf.syslog_facility = LOG_LOCAL1;
	else if (!strcmp((yyvsp[0].string), "local2"))
		conf.syslog_facility = LOG_LOCAL2;
	else if (!strcmp((yyvsp[0].string), "local3"))
		conf.syslog_facility = LOG_LOCAL3;
	else if (!strcmp((yyvsp[0].string), "local4"))
		conf.syslog_facility = LOG_LOCAL4;
	else if (!strcmp((yyvsp[0].string), "local5"))
		conf.syslog_facility = LOG_LOCAL5;
	else if (!strcmp((yyvsp[0].string), "local6"))
		conf.syslog_facility = LOG_LOCAL6;
	else if (!strcmp((yyvsp[0].string), "local7"))
		conf.syslog_facility = LOG_LOCAL7;
	else {
		dlog(LOG_WARNING, "'%s' is not a known syslog facility, "
		     "ignoring", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	}
	free((yyvsp[0].string));

	if (conf.stats.syslog_facility != -1 &&
	    conf.syslog_facility != conf.stats.syslog_facility)
		dlog(LOG_WARNING, "conflicting Syslog facility "
		     "values, defaulting to General");
}
#line 1910 "read_config_yy.c"
    break;

  case 16: /* lock: T_LOCK T_PATH_VAL  */
#line 173 "read_config_yy.y"
{
	if (strlen((yyvsp[0].string)) > FILENAME_MAXLEN) {
		dlog(LOG_ERR, "LockFile path is longer than %u characters",
		     FILENAME_MAXLEN);
		exit(EXIT_FAILURE);
	}
	snprintf(conf.lockfile, sizeof(conf.lockfile), "%s", (yyvsp[0].string));
	free((yyvsp[0].string));
}
#line 1924 "read_config_yy.c"
    break;

  case 17: /* refreshtime: T_REFRESH T_NUMBER  */
#line 184 "read_config_yy.y"
{
	conf.refresh = (yyvsp[0].val);
}
#line 1932 "read_config_yy.c"
    break;

  case 18: /* expiretime: T_EXPIRE T_NUMBER  */
#line 189 "read_config_yy.y"
{
	conf.cache_timeout = (yyvsp[0].val);
}
#line 1940 "read_config_yy.c"
    break;

  case 19: /* timeout: T_TIMEOUT T_NUMBER  */
#line 194 "read_config_yy.y"
{
	conf.commit_timeout = (yyvsp[0].val);
}
#line 1948 "read_config_yy.c"
    break;

  case 20: /* purge: T_PURGE T_NUMBER  */
#line 199 "read_config_yy.y"
{
	conf.purge_timeout = (yyvsp[0].val);
}
#line 1956 "read_config_yy.c"
    break;

  case 21: /* multicast_line: T_MULTICAST '{' multicast_options '}'  */
#line 204 "read_config_yy.y"
{
	if (conf.channel_type_global != CHANNEL_NONE &&
	    conf.channel_type_global != CHANNEL_MCAST) {
		dlog(LOG_ERR, "cannot use `Multicast' with other "
		     "dedicated link protocols!");
		exit(EXIT_FAILURE);
	}
	conf.channel_type_global = CHANNEL_MCAST;
	conf.channel[conf.channel_num].channel_type = CHANNEL_MCAST;
	conf.channel[conf.channel_num].channel_flags = CHANNEL_F_BUFFERED;
	conf.channel_num++;
}
#line 1973 "read_config_yy.c"
    break;

  case 22: /* multicast_line: T_MULTICAST T_DEFAULT '{' multicast_options '}'  */
#line 218 "read_config_yy.y"
{
	if (conf.channel_type_global != CHANNEL_NONE &&
	    conf.channel_type_global != CHANNEL_MCAST) {
		dlog(LOG_ERR, "cannot use `Multicast' with other "
		     "dedicated link protocols!");
		exit(EXIT_FAILURE);
	}
	conf.channel_type_global = CHANNEL_MCAST;
	conf.channel[conf.channel_num].channel_type = CHANNEL_MCAST;
	conf.channel[conf.channel_num].channel_flags = CHANNEL_F_DEFAULT |
						       CHANNEL_F_BUFFERED;
	conf.channel_default = conf.channel_num;
	conf.channel_num++;
}
#line 1992 "read_config_yy.c"
    break;

  case 25: /* multicast_option: T_IPV4_ADDR T_IP  */
#line 237 "read_config_yy.y"
{
	__max_dedicated_links_reached();

	if (!inet_aton((yyvsp[0].string), &conf.channel[conf.channel_num].u.mcast.in)) {
		dlog(LOG_WARNING, "%s is not a valid IPv4 address", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	}

        if (conf.channel[conf.channel_num].u.mcast.ipproto == AF_INET6) {
		dlog(LOG_WARNING, "your multicast address is IPv4 but "
		     "is binded to an IPv6 interface? "
		     "Surely, this is not what you want");
		break;
	}

	free((yyvsp[0].string));
	conf.channel[conf.channel_num].u.mcast.ipproto = AF_INET;
}
#line 2016 "read_config_yy.c"
    break;

  case 26: /* multicast_option: T_IPV6_ADDR T_IP  */
#line 258 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	int err;

	err = inet_pton(AF_INET6, (yyvsp[0].string),
			&conf.channel[conf.channel_num].u.mcast.in);
	if (err == 0) {
		dlog(LOG_WARNING, "%s is not a valid IPv6 address", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	} else if (err < 0) {
		dlog(LOG_ERR, "inet_pton(): IPv6 unsupported!");
		exit(EXIT_FAILURE);
	}

	if (conf.channel[conf.channel_num].u.mcast.ipproto == AF_INET) {
		dlog(LOG_WARNING, "your multicast address is IPv6 but "
		     "is binded to an IPv4 interface? "
		     "Surely this is not what you want");
		free((yyvsp[0].string));
		break;
	}

	conf.channel[conf.channel_num].u.mcast.ipproto = AF_INET6;

	if (conf.channel[conf.channel_num].channel_ifname[0] &&
	    !conf.channel[conf.channel_num].u.mcast.ifa.interface_index6) {
		unsigned int idx;

		idx = if_nametoindex((yyvsp[0].string));
		if (!idx) {
			dlog(LOG_WARNING, "%s is an invalid interface", (yyvsp[0].string));
			free((yyvsp[0].string));
			break;
		}

		conf.channel[conf.channel_num].u.mcast.ifa.interface_index6 = idx;
		conf.channel[conf.channel_num].u.mcast.ipproto = AF_INET6;
	}
	free((yyvsp[0].string));
}
#line 2062 "read_config_yy.c"
    break;

  case 27: /* multicast_option: T_IPV4_IFACE T_IP  */
#line 301 "read_config_yy.y"
{
	__max_dedicated_links_reached();

	if (!inet_aton((yyvsp[0].string), &conf.channel[conf.channel_num].u.mcast.ifa)) {
		dlog(LOG_WARNING, "%s is not a valid IPv4 address", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	}
	free((yyvsp[0].string));

        if (conf.channel[conf.channel_num].u.mcast.ipproto == AF_INET6) {
		dlog(LOG_WARNING, "your multicast interface is IPv4 but "
		     "is binded to an IPv6 interface? "
		     "Surely, this is not what you want");
		break;
	}

	conf.channel[conf.channel_num].u.mcast.ipproto = AF_INET;
}
#line 2086 "read_config_yy.c"
    break;

  case 28: /* multicast_option: T_IPV6_IFACE T_IP  */
#line 322 "read_config_yy.y"
{
	dlog(LOG_WARNING, "`IPv6_interface' not required, ignoring");
	free((yyvsp[0].string));
}
#line 2095 "read_config_yy.c"
    break;

  case 29: /* multicast_option: T_IFACE T_STRING  */
#line 328 "read_config_yy.y"
{
	unsigned int idx;

	__max_dedicated_links_reached();

	strncpy(conf.channel[conf.channel_num].channel_ifname, (yyvsp[0].string), IFNAMSIZ);

	idx = if_nametoindex((yyvsp[0].string));
	if (!idx) {
		dlog(LOG_WARNING, "%s is an invalid interface", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	}

	if (conf.channel[conf.channel_num].u.mcast.ipproto == AF_INET6) {
		conf.channel[conf.channel_num].u.mcast.ifa.interface_index6 = idx;
		conf.channel[conf.channel_num].u.mcast.ipproto = AF_INET6;
	}

	free((yyvsp[0].string));
}
#line 2121 "read_config_yy.c"
    break;

  case 30: /* multicast_option: T_GROUP T_NUMBER  */
#line 351 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	conf.channel[conf.channel_num].u.mcast.port = (yyvsp[0].val);
}
#line 2130 "read_config_yy.c"
    break;

  case 31: /* multicast_option: T_SNDBUFF T_NUMBER  */
#line 357 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	conf.channel[conf.channel_num].u.mcast.sndbuf = (yyvsp[0].val);
}
#line 2139 "read_config_yy.c"
    break;

  case 32: /* multicast_option: T_RCVBUFF T_NUMBER  */
#line 363 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	conf.channel[conf.channel_num].u.mcast.rcvbuf = (yyvsp[0].val);
}
#line 2148 "read_config_yy.c"
    break;

  case 33: /* multicast_option: T_CHECKSUM T_ON  */
#line 369 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	conf.channel[conf.channel_num].u.mcast.checksum = 0;
}
#line 2157 "read_config_yy.c"
    break;

  case 34: /* multicast_option: T_CHECKSUM T_OFF  */
#line 375 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	conf.channel[conf.channel_num].u.mcast.checksum = 1;
}
#line 2166 "read_config_yy.c"
    break;

  case 35: /* udp_line: T_UDP '{' udp_options '}'  */
#line 381 "read_config_yy.y"
{
	if (conf.channel_type_global != CHANNEL_NONE &&
	    conf.channel_type_global != CHANNEL_UDP) {
		dlog(LOG_ERR, "cannot use `UDP' with other "
		     "dedicated link protocols!");
		exit(EXIT_FAILURE);
	}
	conf.channel_type_global = CHANNEL_UDP;
	conf.channel[conf.channel_num].channel_type = CHANNEL_UDP;
	conf.channel[conf.channel_num].channel_flags = CHANNEL_F_BUFFERED;
	conf.channel_num++;
}
#line 2183 "read_config_yy.c"
    break;

  case 36: /* udp_line: T_UDP T_DEFAULT '{' udp_options '}'  */
#line 395 "read_config_yy.y"
{
	if (conf.channel_type_global != CHANNEL_NONE &&
	    conf.channel_type_global != CHANNEL_UDP) {
		dlog(LOG_ERR, "cannot use `UDP' with other "
		     "dedicated link protocols!");
		exit(EXIT_FAILURE);
	}
	conf.channel_type_global = CHANNEL_UDP;
	conf.channel[conf.channel_num].channel_type = CHANNEL_UDP;
	conf.channel[conf.channel_num].channel_flags = CHANNEL_F_DEFAULT |
						       CHANNEL_F_BUFFERED;
	conf.channel_default = conf.channel_num;
	conf.channel_num++;
}
#line 2202 "read_config_yy.c"
    break;

  case 39: /* udp_option: T_IPV4_ADDR T_IP  */
#line 414 "read_config_yy.y"
{
	__max_dedicated_links_reached();

	if (!inet_aton((yyvsp[0].string), &conf.channel[conf.channel_num].u.udp.server.ipv4)) {
		dlog(LOG_WARNING, "%s is not a valid IPv4 address", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	}
	free((yyvsp[0].string));
	conf.channel[conf.channel_num].u.udp.ipproto = AF_INET;
}
#line 2218 "read_config_yy.c"
    break;

  case 40: /* udp_option: T_IPV6_ADDR T_IP  */
#line 427 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	int err;

	err = inet_pton(AF_INET6, (yyvsp[0].string),
			&conf.channel[conf.channel_num].u.udp.server.ipv6);
	if (err == 0) {
		dlog(LOG_WARNING, "%s is not a valid IPv6 address", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	} else if (err < 0) {
		dlog(LOG_ERR, "inet_pton(): IPv6 unsupported!");
		exit(EXIT_FAILURE);
	}

	free((yyvsp[0].string));
	conf.channel[conf.channel_num].u.udp.ipproto = AF_INET6;
}
#line 2241 "read_config_yy.c"
    break;

  case 41: /* udp_option: T_IPV4_DEST_ADDR T_IP  */
#line 447 "read_config_yy.y"
{
	__max_dedicated_links_reached();

	if (!inet_aton((yyvsp[0].string), &conf.channel[conf.channel_num].u.udp.client)) {
		dlog(LOG_WARNING, "%s is not a valid IPv4 address", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	}
	free((yyvsp[0].string));
	conf.channel[conf.channel_num].u.udp.ipproto = AF_INET;
}
#line 2257 "read_config_yy.c"
    break;

  case 42: /* udp_option: T_IPV6_DEST_ADDR T_IP  */
#line 460 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	int err;

	err = inet_pton(AF_INET6, (yyvsp[0].string),
			&conf.channel[conf.channel_num].u.udp.client);
	if (err == 0) {
		dlog(LOG_WARNING, "%s is not a valid IPv6 address", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	} else {
		dlog(LOG_ERR, "inet_pton(): IPv6 unsupported!");
		exit(EXIT_FAILURE);
	}

	free((yyvsp[0].string));
	conf.channel[conf.channel_num].u.udp.ipproto = AF_INET6;
}
#line 2280 "read_config_yy.c"
    break;

  case 43: /* udp_option: T_IFACE T_STRING  */
#line 480 "read_config_yy.y"
{
	int idx;

	__max_dedicated_links_reached();
	strncpy(conf.channel[conf.channel_num].channel_ifname, (yyvsp[0].string), IFNAMSIZ);

	idx = if_nametoindex((yyvsp[0].string));
	if (!idx) {
		dlog(LOG_WARNING, "%s is an invalid interface", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	}
	conf.channel[conf.channel_num].u.udp.server.ipv6.scope_id = idx;

	free((yyvsp[0].string));
}
#line 2301 "read_config_yy.c"
    break;

  case 44: /* udp_option: T_PORT T_NUMBER  */
#line 498 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	conf.channel[conf.channel_num].u.udp.port = (yyvsp[0].val);
}
#line 2310 "read_config_yy.c"
    break;

  case 45: /* udp_option: T_SNDBUFF T_NUMBER  */
#line 504 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	conf.channel[conf.channel_num].u.udp.sndbuf = (yyvsp[0].val);
}
#line 2319 "read_config_yy.c"
    break;

  case 46: /* udp_option: T_RCVBUFF T_NUMBER  */
#line 510 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	conf.channel[conf.channel_num].u.udp.rcvbuf = (yyvsp[0].val);
}
#line 2328 "read_config_yy.c"
    break;

  case 47: /* udp_option: T_CHECKSUM T_ON  */
#line 516 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	conf.channel[conf.channel_num].u.udp.checksum = 0;
}
#line 2337 "read_config_yy.c"
    break;

  case 48: /* udp_option: T_CHECKSUM T_OFF  */
#line 522 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	conf.channel[conf.channel_num].u.udp.checksum = 1;
}
#line 2346 "read_config_yy.c"
    break;

  case 49: /* tcp_line: T_TCP '{' tcp_options '}'  */
#line 528 "read_config_yy.y"
{
	if (conf.channel_type_global != CHANNEL_NONE &&
	    conf.channel_type_global != CHANNEL_TCP) {
		dlog(LOG_ERR, "cannot use `TCP' with other "
		     "dedicated link protocols!");
		exit(EXIT_FAILURE);
	}
	conf.channel_type_global = CHANNEL_TCP;
	conf.channel[conf.channel_num].channel_type = CHANNEL_TCP;
	conf.channel[conf.channel_num].channel_flags = CHANNEL_F_BUFFERED |
						       CHANNEL_F_STREAM |
						       CHANNEL_F_ERRORS;
	conf.channel_num++;
}
#line 2365 "read_config_yy.c"
    break;

  case 50: /* tcp_line: T_TCP T_DEFAULT '{' tcp_options '}'  */
#line 544 "read_config_yy.y"
{
	if (conf.channel_type_global != CHANNEL_NONE &&
	    conf.channel_type_global != CHANNEL_TCP) {
		dlog(LOG_ERR, "cannot use `TCP' with other "
		     "dedicated link protocols!");
		exit(EXIT_FAILURE);
	}
	conf.channel_type_global = CHANNEL_TCP;
	conf.channel[conf.channel_num].channel_type = CHANNEL_TCP;
	conf.channel[conf.channel_num].channel_flags = CHANNEL_F_DEFAULT |
						       CHANNEL_F_BUFFERED |
						       CHANNEL_F_STREAM |
						       CHANNEL_F_ERRORS;
	conf.channel_default = conf.channel_num;
	conf.channel_num++;
}
#line 2386 "read_config_yy.c"
    break;

  case 53: /* tcp_option: T_IPV4_ADDR T_IP  */
#line 565 "read_config_yy.y"
{
	__max_dedicated_links_reached();

	if (!inet_aton((yyvsp[0].string), &conf.channel[conf.channel_num].u.tcp.server.ipv4)) {
		dlog(LOG_WARNING, "%s is not a valid IPv4 address", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	}
	free((yyvsp[0].string));
	conf.channel[conf.channel_num].u.tcp.ipproto = AF_INET;
}
#line 2402 "read_config_yy.c"
    break;

  case 54: /* tcp_option: T_IPV6_ADDR T_IP  */
#line 578 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	int err;

	err = inet_pton(AF_INET6, (yyvsp[0].string),
			&conf.channel[conf.channel_num].u.tcp.server.ipv6);
	if (err == 0) {
		dlog(LOG_WARNING, "%s is not a valid IPv6 address", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	} else if (err < 0) {
		dlog(LOG_ERR, "inet_pton(): IPv6 unsupported!");
		exit(EXIT_FAILURE);
	}

	free((yyvsp[0].string));
	conf.channel[conf.channel_num].u.tcp.ipproto = AF_INET6;
}
#line 2425 "read_config_yy.c"
    break;

  case 55: /* tcp_option: T_IPV4_DEST_ADDR T_IP  */
#line 598 "read_config_yy.y"
{
	__max_dedicated_links_reached();

	if (!inet_aton((yyvsp[0].string), &conf.channel[conf.channel_num].u.tcp.client)) {
		dlog(LOG_WARNING, "%s is not a valid IPv4 address", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	}
	free((yyvsp[0].string));
	conf.channel[conf.channel_num].u.tcp.ipproto = AF_INET;
}
#line 2441 "read_config_yy.c"
    break;

  case 56: /* tcp_option: T_IPV6_DEST_ADDR T_IP  */
#line 611 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	int err;

	err = inet_pton(AF_INET6, (yyvsp[0].string),
			&conf.channel[conf.channel_num].u.tcp.client);
	if (err == 0) {
		dlog(LOG_WARNING, "%s is not a valid IPv6 address", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	} else if (err < 0) {
		dlog(LOG_ERR, "inet_pton(): IPv6 unsupported!");
		exit(EXIT_FAILURE);
	}

	free((yyvsp[0].string));
	conf.channel[conf.channel_num].u.tcp.ipproto = AF_INET6;
}
#line 2464 "read_config_yy.c"
    break;

  case 57: /* tcp_option: T_IFACE T_STRING  */
#line 631 "read_config_yy.y"
{
	int idx;

	__max_dedicated_links_reached();
	strncpy(conf.channel[conf.channel_num].channel_ifname, (yyvsp[0].string), IFNAMSIZ);

	idx = if_nametoindex((yyvsp[0].string));
	if (!idx) {
		dlog(LOG_WARNING, "%s is an invalid interface", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	}
	conf.channel[conf.channel_num].u.tcp.server.ipv6.scope_id = idx;

	free((yyvsp[0].string));
}
#line 2485 "read_config_yy.c"
    break;

  case 58: /* tcp_option: T_PORT T_NUMBER  */
#line 649 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	conf.channel[conf.channel_num].u.tcp.port = (yyvsp[0].val);
}
#line 2494 "read_config_yy.c"
    break;

  case 59: /* tcp_option: T_SNDBUFF T_NUMBER  */
#line 655 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	conf.channel[conf.channel_num].u.tcp.sndbuf = (yyvsp[0].val);
}
#line 2503 "read_config_yy.c"
    break;

  case 60: /* tcp_option: T_RCVBUFF T_NUMBER  */
#line 661 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	conf.channel[conf.channel_num].u.tcp.rcvbuf = (yyvsp[0].val);
}
#line 2512 "read_config_yy.c"
    break;

  case 61: /* tcp_option: T_CHECKSUM T_ON  */
#line 667 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	conf.channel[conf.channel_num].u.tcp.checksum = 0;
}
#line 2521 "read_config_yy.c"
    break;

  case 62: /* tcp_option: T_CHECKSUM T_OFF  */
#line 673 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	conf.channel[conf.channel_num].u.tcp.checksum = 1;
}
#line 2530 "read_config_yy.c"
    break;

  case 63: /* tcp_option: T_ERROR_QUEUE_LENGTH T_NUMBER  */
#line 679 "read_config_yy.y"
{
	__max_dedicated_links_reached();
	CONFIG(channelc).error_queue_length = (yyvsp[0].val);
}
#line 2539 "read_config_yy.c"
    break;

  case 64: /* hashsize: T_HASHSIZE T_NUMBER  */
#line 685 "read_config_yy.y"
{
	conf.hashsize = (yyvsp[0].val);
}
#line 2547 "read_config_yy.c"
    break;

  case 65: /* hashlimit: T_HASHLIMIT T_NUMBER  */
#line 690 "read_config_yy.y"
{
	conf.limit = (yyvsp[0].val);
}
#line 2555 "read_config_yy.c"
    break;

  case 69: /* unix_option: T_PATH T_PATH_VAL  */
#line 701 "read_config_yy.y"
{
	if (strlen((yyvsp[0].string)) > UNIX_PATH_MAX) {
		dlog(LOG_ERR, "Path is longer than %u characters",
		     UNIX_PATH_MAX);
		exit(EXIT_FAILURE);
	}
	snprintf(conf.local.path, sizeof(conf.local.path), "%s", (yyvsp[0].string));
	free((yyvsp[0].string));
}
#line 2569 "read_config_yy.c"
    break;

  case 70: /* unix_option: T_BACKLOG T_NUMBER  */
#line 712 "read_config_yy.y"
{
	dlog(LOG_WARNING, "deprecated unix backlog configuration, ignoring.");
}
#line 2577 "read_config_yy.c"
    break;

  case 71: /* sync: T_SYNC '{' sync_list '}'  */
#line 717 "read_config_yy.y"
{
	if (conf.flags & CTD_STATS_MODE) {
		dlog(LOG_ERR, "cannot use both `Stats' and `Sync' "
		     "clauses in conntrackd.conf");
		exit(EXIT_FAILURE);
	}
	conf.flags |= CTD_SYNC_MODE;
}
#line 2590 "read_config_yy.c"
    break;

  case 88: /* option: T_TCP_WINDOW_TRACKING T_ON  */
#line 749 "read_config_yy.y"
{
	CONFIG(sync).tcp_window_tracking = 1;
}
#line 2598 "read_config_yy.c"
    break;

  case 89: /* option: T_TCP_WINDOW_TRACKING T_OFF  */
#line 754 "read_config_yy.y"
{
	CONFIG(sync).tcp_window_tracking = 0;
}
#line 2606 "read_config_yy.c"
    break;

  case 90: /* option: T_EXPECT_SYNC T_ON  */
#line 759 "read_config_yy.y"
{
	CONFIG(flags) |= CTD_EXPECT;
	CONFIG(netlink).subsys_id = NFNL_SUBSYS_NONE;
	CONFIG(netlink).groups = NF_NETLINK_CONNTRACK_NEW |
				 NF_NETLINK_CONNTRACK_UPDATE |
				 NF_NETLINK_CONNTRACK_DESTROY |
				 NF_NETLINK_CONNTRACK_EXP_NEW |
				 NF_NETLINK_CONNTRACK_EXP_UPDATE |
				 NF_NETLINK_CONNTRACK_EXP_DESTROY;
}
#line 2621 "read_config_yy.c"
    break;

  case 91: /* option: T_EXPECT_SYNC T_OFF  */
#line 771 "read_config_yy.y"
{
	CONFIG(netlink).subsys_id = NFNL_SUBSYS_CTNETLINK;
	CONFIG(netlink).groups = NF_NETLINK_CONNTRACK_NEW |
				 NF_NETLINK_CONNTRACK_UPDATE |
				 NF_NETLINK_CONNTRACK_DESTROY;
}
#line 2632 "read_config_yy.c"
    break;

  case 92: /* option: T_EXPECT_SYNC '{' expect_list '}'  */
#line 779 "read_config_yy.y"
{
	CONFIG(flags) |= CTD_EXPECT;
	CONFIG(netlink).subsys_id = NFNL_SUBSYS_NONE;
	CONFIG(netlink).groups = NF_NETLINK_CONNTRACK_NEW |
				 NF_NETLINK_CONNTRACK_UPDATE |
				 NF_NETLINK_CONNTRACK_DESTROY |
				 NF_NETLINK_CONNTRACK_EXP_NEW |
				 NF_NETLINK_CONNTRACK_EXP_UPDATE |
				 NF_NETLINK_CONNTRACK_EXP_DESTROY;
}
#line 2647 "read_config_yy.c"
    break;

  case 95: /* expect_item: T_STRING  */
#line 794 "read_config_yy.y"
{
	exp_filter_add(STATE(exp_filter), (yyvsp[0].string));
	free((yyvsp[0].string));
}
#line 2656 "read_config_yy.c"
    break;

  case 96: /* sync_mode_alarm: T_SYNC_MODE T_ALARM '{' sync_mode_alarm_list '}'  */
#line 800 "read_config_yy.y"
{
	conf.flags |= CTD_SYNC_ALARM;
}
#line 2664 "read_config_yy.c"
    break;

  case 97: /* sync_mode_ftfw: T_SYNC_MODE T_FTFW '{' sync_mode_ftfw_list '}'  */
#line 805 "read_config_yy.y"
{
	conf.flags |= CTD_SYNC_FTFW;
}
#line 2672 "read_config_yy.c"
    break;

  case 98: /* sync_mode_notrack: T_SYNC_MODE T_NOTRACK '{' sync_mode_notrack_list '}'  */
#line 810 "read_config_yy.y"
{
	conf.flags |= CTD_SYNC_NOTRACK;
}
#line 2680 "read_config_yy.c"
    break;

  case 120: /* disable_internal_cache: T_DISABLE_INTERNAL_CACHE T_ON  */
#line 845 "read_config_yy.y"
{
	conf.sync.internal_cache_disable = 1;
}
#line 2688 "read_config_yy.c"
    break;

  case 121: /* disable_internal_cache: T_DISABLE_INTERNAL_CACHE T_OFF  */
#line 850 "read_config_yy.y"
{
	conf.sync.internal_cache_disable = 0;
}
#line 2696 "read_config_yy.c"
    break;

  case 122: /* disable_external_cache: T_DISABLE_EXTERNAL_CACHE T_ON  */
#line 855 "read_config_yy.y"
{
	conf.sync.external_cache_disable = 1;
}
#line 2704 "read_config_yy.c"
    break;

  case 123: /* disable_external_cache: T_DISABLE_EXTERNAL_CACHE T_OFF  */
#line 860 "read_config_yy.y"
{
	conf.sync.external_cache_disable = 0;
}
#line 2712 "read_config_yy.c"
    break;

  case 124: /* resend_queue_size: T_RESEND_QUEUE_SIZE T_NUMBER  */
#line 865 "read_config_yy.y"
{
	conf.resend_queue_size = (yyvsp[0].val);
}
#line 2720 "read_config_yy.c"
    break;

  case 125: /* startup_resync: T_STARTUP_RESYNC T_ON  */
#line 870 "read_config_yy.y"
{
	conf.startup_resync = 1;
}
#line 2728 "read_config_yy.c"
    break;

  case 126: /* startup_resync: T_STARTUP_RESYNC T_OFF  */
#line 875 "read_config_yy.y"
{
	conf.startup_resync = 0;
}
#line 2736 "read_config_yy.c"
    break;

  case 127: /* window_size: T_WINDOWSIZE T_NUMBER  */
#line 880 "read_config_yy.y"
{
	conf.window_size = (yyvsp[0].val);
}
#line 2744 "read_config_yy.c"
    break;

  case 130: /* tcp_state: T_SYN_SENT  */
#line 888 "read_config_yy.y"
{
	ct_filter_add_state(STATE(us_filter),
			    IPPROTO_TCP,
			    TCP_CONNTRACK_SYN_SENT);

	__kernel_filter_add_state(TCP_CONNTRACK_SYN_SENT);
}
#line 2756 "read_config_yy.c"
    break;

  case 131: /* tcp_state: T_SYN_RECV  */
#line 896 "read_config_yy.y"
{
	ct_filter_add_state(STATE(us_filter),
			    IPPROTO_TCP,
			    TCP_CONNTRACK_SYN_RECV);

	__kernel_filter_add_state(TCP_CONNTRACK_SYN_RECV);
}
#line 2768 "read_config_yy.c"
    break;

  case 132: /* tcp_state: T_ESTABLISHED  */
#line 904 "read_config_yy.y"
{
	ct_filter_add_state(STATE(us_filter),
			    IPPROTO_TCP,
			    TCP_CONNTRACK_ESTABLISHED);

	__kernel_filter_add_state(TCP_CONNTRACK_ESTABLISHED);
}
#line 2780 "read_config_yy.c"
    break;

  case 133: /* tcp_state: T_FIN_WAIT  */
#line 912 "read_config_yy.y"
{
	ct_filter_add_state(STATE(us_filter),
			    IPPROTO_TCP,
			    TCP_CONNTRACK_FIN_WAIT);

	__kernel_filter_add_state(TCP_CONNTRACK_FIN_WAIT);
}
#line 2792 "read_config_yy.c"
    break;

  case 134: /* tcp_state: T_CLOSE_WAIT  */
#line 920 "read_config_yy.y"
{
	ct_filter_add_state(STATE(us_filter),
			    IPPROTO_TCP,
			    TCP_CONNTRACK_CLOSE_WAIT);

	__kernel_filter_add_state(TCP_CONNTRACK_CLOSE_WAIT);
}
#line 2804 "read_config_yy.c"
    break;

  case 135: /* tcp_state: T_LAST_ACK  */
#line 928 "read_config_yy.y"
{
	ct_filter_add_state(STATE(us_filter),
			    IPPROTO_TCP,
			    TCP_CONNTRACK_LAST_ACK);

	__kernel_filter_add_state(TCP_CONNTRACK_LAST_ACK);
}
#line 2816 "read_config_yy.c"
    break;

  case 136: /* tcp_state: T_TIME_WAIT  */
#line 936 "read_config_yy.y"
{
	ct_filter_add_state(STATE(us_filter),
			    IPPROTO_TCP,
			    TCP_CONNTRACK_TIME_WAIT);

	__kernel_filter_add_state(TCP_CONNTRACK_TIME_WAIT);
}
#line 2828 "read_config_yy.c"
    break;

  case 137: /* tcp_state: T_CLOSE  */
#line 944 "read_config_yy.y"
{
	ct_filter_add_state(STATE(us_filter),
			    IPPROTO_TCP,
			    TCP_CONNTRACK_CLOSE);

	__kernel_filter_add_state(TCP_CONNTRACK_CLOSE);
}
#line 2840 "read_config_yy.c"
    break;

  case 138: /* tcp_state: T_LISTEN  */
#line 952 "read_config_yy.y"
{
	ct_filter_add_state(STATE(us_filter),
			    IPPROTO_TCP,
			    TCP_CONNTRACK_LISTEN);

	__kernel_filter_add_state(TCP_CONNTRACK_LISTEN);
}
#line 2852 "read_config_yy.c"
    break;

  case 160: /* systemd: T_SYSTEMD T_ON  */
#line 986 "read_config_yy.y"
                                { conf.systemd = 1; }
#line 2858 "read_config_yy.c"
    break;

  case 161: /* systemd: T_SYSTEMD T_OFF  */
#line 987 "read_config_yy.y"
                                { conf.systemd = 0; }
#line 2864 "read_config_yy.c"
    break;

  case 162: /* netlink_buffer_size: T_BUFFER_SIZE T_NUMBER  */
#line 990 "read_config_yy.y"
{
	conf.netlink_buffer_size = (yyvsp[0].val);
}
#line 2872 "read_config_yy.c"
    break;

  case 163: /* netlink_buffer_size_max_grown: T_BUFFER_SIZE_MAX_GROWN T_NUMBER  */
#line 995 "read_config_yy.y"
{
	conf.netlink_buffer_size_max_grown = (yyvsp[0].val);
}
#line 2880 "read_config_yy.c"
    break;

  case 164: /* netlink_overrun_resync: T_NETLINK_OVERRUN_RESYNC T_ON  */
#line 1000 "read_config_yy.y"
{
	conf.nl_overrun_resync = 30;
}
#line 2888 "read_config_yy.c"
    break;

  case 165: /* netlink_overrun_resync: T_NETLINK_OVERRUN_RESYNC T_OFF  */
#line 1005 "read_config_yy.y"
{
	conf.nl_overrun_resync = -1;
}
#line 2896 "read_config_yy.c"
    break;

  case 166: /* netlink_overrun_resync: T_NETLINK_OVERRUN_RESYNC T_NUMBER  */
#line 1010 "read_config_yy.y"
{
	conf.nl_overrun_resync = (yyvsp[0].val);
}
#line 2904 "read_config_yy.c"
    break;

  case 167: /* netlink_events_reliable: T_NETLINK_EVENTS_RELIABLE T_ON  */
#line 1015 "read_config_yy.y"
{
	conf.netlink.events_reliable = 1;
}
#line 2912 "read_config_yy.c"
    break;

  case 168: /* netlink_events_reliable: T_NETLINK_EVENTS_RELIABLE T_OFF  */
#line 1020 "read_config_yy.y"
{
	conf.netlink.events_reliable = 0;
}
#line 2920 "read_config_yy.c"
    break;

  case 169: /* nice: T_NICE T_SIGNED_NUMBER  */
#line 1025 "read_config_yy.y"
{
	dlog(LOG_WARNING, "deprecated nice configuration, ignoring. The "
	     "nice value can be set externally with nice(1) and renice(1).");
}
#line 2929 "read_config_yy.c"
    break;

  case 173: /* scheduler_line: T_TYPE T_STRING  */
#line 1037 "read_config_yy.y"
{
	if (strcasecmp((yyvsp[0].string), "rr") == 0) {
		conf.sched.type = SCHED_RR;
	} else if (strcasecmp((yyvsp[0].string), "fifo") == 0) {
		conf.sched.type = SCHED_FIFO;
	} else {
		dlog(LOG_ERR, "unknown scheduler `%s'", (yyvsp[0].string));
		free((yyvsp[0].string));
		exit(EXIT_FAILURE);
	}

	free((yyvsp[0].string));
}
#line 2947 "read_config_yy.c"
    break;

  case 174: /* scheduler_line: T_PRIO T_NUMBER  */
#line 1052 "read_config_yy.y"
{
	conf.sched.prio = (yyvsp[0].val);
	if (conf.sched.prio < 0 || conf.sched.prio > 99) {
		dlog(LOG_ERR, "`Priority' must be [0, 99]\n");
		exit(EXIT_FAILURE);
	}
}
#line 2959 "read_config_yy.c"
    break;

  case 175: /* event_iterations_limit: T_EVENT_ITER_LIMIT T_NUMBER  */
#line 1061 "read_config_yy.y"
{
	CONFIG(event_iterations_limit) = (yyvsp[0].val);
}
#line 2967 "read_config_yy.c"
    break;

  case 176: /* poll_secs: T_POLL_SECS T_NUMBER  */
#line 1066 "read_config_yy.y"
{
	conf.flags |= CTD_POLL;
	conf.poll_kernel_secs = (yyvsp[0].val);
	if (conf.poll_kernel_secs == 0) {
		dlog(LOG_ERR, "`PollSecs' clause must be > 0");
		exit(EXIT_FAILURE);
	}
}
#line 2980 "read_config_yy.c"
    break;

  case 177: /* filter: T_FILTER '{' filter_list '}'  */
#line 1076 "read_config_yy.y"
{
	CONFIG(filter_from_kernelspace) = 0;
}
#line 2988 "read_config_yy.c"
    break;

  case 178: /* filter: T_FILTER T_FROM T_USERSPACE '{' filter_list '}'  */
#line 1081 "read_config_yy.y"
{
	CONFIG(filter_from_kernelspace) = 0;
}
#line 2996 "read_config_yy.c"
    break;

  case 179: /* filter: T_FILTER T_FROM T_KERNELSPACE '{' filter_list '}'  */
#line 1086 "read_config_yy.y"
{
	CONFIG(filter_from_kernelspace) = 1;
}
#line 3004 "read_config_yy.c"
    break;

  case 182: /* filter_item: T_PROTOCOL T_ACCEPT '{' filter_protocol_list '}'  */
#line 1094 "read_config_yy.y"
{
	ct_filter_set_logic(STATE(us_filter),
			    CT_FILTER_L4PROTO,
			    CT_FILTER_POSITIVE);

	__kernel_filter_start();
}
#line 3016 "read_config_yy.c"
    break;

  case 183: /* filter_item: T_PROTOCOL T_IGNORE '{' filter_protocol_list '}'  */
#line 1103 "read_config_yy.y"
{
	ct_filter_set_logic(STATE(us_filter),
			    CT_FILTER_L4PROTO,
			    CT_FILTER_NEGATIVE);

	__kernel_filter_start();

	nfct_filter_set_logic(STATE(filter),
			      NFCT_FILTER_L4PROTO,
			      NFCT_FILTER_LOGIC_NEGATIVE);
}
#line 3032 "read_config_yy.c"
    break;

  case 186: /* filter_protocol_item: T_STRING  */
#line 1119 "read_config_yy.y"
{
	struct protoent *pent;

	pent = getprotobyname((yyvsp[0].string));
	if (pent == NULL) {
		dlog(LOG_WARNING, "getprotobyname() cannot find "
		     "protocol `%s' in /etc/protocols", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	}
	free((yyvsp[0].string));
	ct_filter_add_proto(STATE(us_filter), pent->p_proto);

	__kernel_filter_start();

	nfct_filter_add_attr_u32(STATE(filter),
				 NFCT_FILTER_L4PROTO,
				 pent->p_proto);
}
#line 3056 "read_config_yy.c"
    break;

  case 187: /* filter_protocol_item: T_TCP  */
#line 1140 "read_config_yy.y"
{
	struct protoent *pent;

	pent = getprotobyname("tcp");
	if (pent == NULL) {
		dlog(LOG_WARNING, "getprotobyname() cannot find "
		     "protocol `tcp' in /etc/protocols");
		break;
	}
	ct_filter_add_proto(STATE(us_filter), pent->p_proto);

	__kernel_filter_start();

	nfct_filter_add_attr_u32(STATE(filter),
				 NFCT_FILTER_L4PROTO,
				 pent->p_proto);
}
#line 3078 "read_config_yy.c"
    break;

  case 188: /* filter_protocol_item: T_UDP  */
#line 1159 "read_config_yy.y"
{
	struct protoent *pent;

	pent = getprotobyname("udp");
	if (pent == NULL) {
		dlog(LOG_WARNING, "getprotobyname() cannot find "
					"protocol `udp' in /etc/protocols");
		break;
	}
	ct_filter_add_proto(STATE(us_filter), pent->p_proto);

	__kernel_filter_start();

	nfct_filter_add_attr_u32(STATE(filter),
				 NFCT_FILTER_L4PROTO,
				 pent->p_proto);
}
#line 3100 "read_config_yy.c"
    break;

  case 189: /* filter_item: T_ADDRESS T_ACCEPT '{' filter_address_list '}'  */
#line 1178 "read_config_yy.y"
{
	ct_filter_set_logic(STATE(us_filter),
			    CT_FILTER_ADDRESS,
			    CT_FILTER_POSITIVE);

	__kernel_filter_start();
}
#line 3112 "read_config_yy.c"
    break;

  case 190: /* filter_item: T_ADDRESS T_IGNORE '{' filter_address_list '}'  */
#line 1187 "read_config_yy.y"
{
	ct_filter_set_logic(STATE(us_filter),
			    CT_FILTER_ADDRESS,
			    CT_FILTER_NEGATIVE);

	__kernel_filter_start();

	nfct_filter_set_logic(STATE(filter),
			      NFCT_FILTER_SRC_IPV4,
			      NFCT_FILTER_LOGIC_NEGATIVE);
	nfct_filter_set_logic(STATE(filter),
			      NFCT_FILTER_DST_IPV4,
			      NFCT_FILTER_LOGIC_NEGATIVE);
	nfct_filter_set_logic(STATE(filter),
			      NFCT_FILTER_SRC_IPV6,
			      NFCT_FILTER_LOGIC_NEGATIVE);
	nfct_filter_set_logic(STATE(filter),
			      NFCT_FILTER_DST_IPV6,
			      NFCT_FILTER_LOGIC_NEGATIVE);
}
#line 3137 "read_config_yy.c"
    break;

  case 193: /* filter_address_item: T_IPV4_ADDR T_IP  */
#line 1212 "read_config_yy.y"
{
	union inet_address ip;
	char *slash;
	unsigned int cidr = 32;

	memset(&ip, 0, sizeof(union inet_address));

	slash = strchr((yyvsp[0].string), '/');
	if (slash) {
		*slash = '\0';
		cidr = atoi(slash+1);
		if (cidr > 32) {
			dlog(LOG_WARNING, "%s/%d is not a valid network, "
			     "ignoring", (yyvsp[0].string), cidr);
			free((yyvsp[0].string));
			break;
		}
	}

	if (!inet_aton((yyvsp[0].string), &ip.ipv4)) {
		dlog(LOG_WARNING, "%s is not a valid IPv4, ignoring", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	}

	if (slash && cidr < 32) {
		/* network byte order */
		struct ct_filter_netmask_ipv4 tmp = {
			.ip = ip.ipv4,
			.mask = ipv4_cidr2mask_net(cidr)
		};

		if (!ct_filter_add_netmask(STATE(us_filter), &tmp, AF_INET)) {
			if (errno == EEXIST)
				dlog(LOG_WARNING, "netmask %s is "
				     "repeated in the ignore pool", (yyvsp[0].string));
		}
	} else {
		if (!ct_filter_add_ip(STATE(us_filter), &ip, AF_INET)) {
			if (errno == EEXIST)
				dlog(LOG_WARNING, "IP %s is repeated in "
				     "the ignore pool", (yyvsp[0].string));
			if (errno == ENOSPC)
				dlog(LOG_WARNING, "too many IP in the "
				     "ignore pool!");
		}
	}
	free((yyvsp[0].string));
	__kernel_filter_start();

	/* host byte order */
	struct nfct_filter_ipv4 filter_ipv4 = {
		.addr = ntohl(ip.ipv4),
		.mask = ipv4_cidr2mask_host(cidr),
	};

	nfct_filter_add_attr(STATE(filter), NFCT_FILTER_SRC_IPV4, &filter_ipv4);
	nfct_filter_add_attr(STATE(filter), NFCT_FILTER_DST_IPV4, &filter_ipv4);
}
#line 3201 "read_config_yy.c"
    break;

  case 194: /* filter_address_item: T_IPV6_ADDR T_IP  */
#line 1273 "read_config_yy.y"
{
	union inet_address ip;
	char *slash;
	int cidr = 128;
	struct nfct_filter_ipv6 filter_ipv6;
	int err;

	memset(&ip, 0, sizeof(union inet_address));

	slash = strchr((yyvsp[0].string), '/');
	if (slash) {
		*slash = '\0';
		cidr = atoi(slash+1);
		if (cidr > 128) {
			dlog(LOG_WARNING, "%s/%d is not a valid network, "
			     "ignoring", (yyvsp[0].string), cidr);
			free((yyvsp[0].string));
			break;
		}
	}

	err = inet_pton(AF_INET6, (yyvsp[0].string), &ip.ipv6);
	if (err == 0) {
		dlog(LOG_WARNING, "%s is not a valid IPv6, ignoring", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	} else if (err < 0) {
		dlog(LOG_ERR, "inet_pton(): IPv6 unsupported!");
		exit(EXIT_FAILURE);
	}

	if (slash && cidr < 128) {
		struct ct_filter_netmask_ipv6 tmp;

		memcpy(tmp.ip, ip.ipv6, sizeof(uint32_t)*4);
		ipv6_cidr2mask_net(cidr, tmp.mask);
		if (!ct_filter_add_netmask(STATE(us_filter), &tmp, AF_INET6)) {
			if (errno == EEXIST)
				dlog(LOG_WARNING, "netmask %s is "
				     "repeated in the ignore pool", (yyvsp[0].string));
		}
	} else {
		if (!ct_filter_add_ip(STATE(us_filter), &ip, AF_INET6)) {
			if (errno == EEXIST)
				dlog(LOG_WARNING, "IP %s is repeated in "
				     "the ignore pool", (yyvsp[0].string));
			if (errno == ENOSPC)
				dlog(LOG_WARNING, "too many IP in the "
				     "ignore pool!");
		}
	}
	free((yyvsp[0].string));
	__kernel_filter_start();

	/* host byte order */
	ipv6_addr2addr_host(ip.ipv6, filter_ipv6.addr);
	ipv6_cidr2mask_host(cidr, filter_ipv6.mask);

	nfct_filter_add_attr(STATE(filter), NFCT_FILTER_SRC_IPV6, &filter_ipv6);
	nfct_filter_add_attr(STATE(filter), NFCT_FILTER_DST_IPV6, &filter_ipv6);
}
#line 3267 "read_config_yy.c"
    break;

  case 195: /* filter_item: T_STATE T_ACCEPT '{' filter_state_list '}'  */
#line 1336 "read_config_yy.y"
{
	ct_filter_set_logic(STATE(us_filter),
			    CT_FILTER_STATE,
			    CT_FILTER_POSITIVE);

	__kernel_filter_start();
}
#line 3279 "read_config_yy.c"
    break;

  case 196: /* filter_item: T_STATE T_IGNORE '{' filter_state_list '}'  */
#line 1345 "read_config_yy.y"
{
	ct_filter_set_logic(STATE(us_filter),
			    CT_FILTER_STATE,
			    CT_FILTER_NEGATIVE);


	__kernel_filter_start();

	nfct_filter_set_logic(STATE(filter),
			      NFCT_FILTER_L4PROTO_STATE,
			      NFCT_FILTER_LOGIC_NEGATIVE);
}
#line 3296 "read_config_yy.c"
    break;

  case 200: /* stats: T_STATS '{' stats_list '}'  */
#line 1364 "read_config_yy.y"
{
	if (conf.flags & CTD_SYNC_MODE) {
		dlog(LOG_ERR, "cannot use both `Stats' and `Sync' "
		     "clauses in conntrackd.conf");
		exit(EXIT_FAILURE);
	}
	conf.flags |= CTD_STATS_MODE;
}
#line 3309 "read_config_yy.c"
    break;

  case 207: /* stat_logfile_bool: T_LOG T_ON  */
#line 1384 "read_config_yy.y"
{
	strncpy(conf.stats.logfile, DEFAULT_STATS_LOGFILE, FILENAME_MAXLEN);
}
#line 3317 "read_config_yy.c"
    break;

  case 208: /* stat_logfile_bool: T_LOG T_OFF  */
#line 1389 "read_config_yy.y"
{
}
#line 3324 "read_config_yy.c"
    break;

  case 209: /* stat_logfile_path: T_LOG T_PATH_VAL  */
#line 1393 "read_config_yy.y"
{
	if (strlen((yyvsp[0].string)) > FILENAME_MAXLEN) {
		dlog(LOG_ERR, "stats LogFile path is longer than %u characters",
		     FILENAME_MAXLEN);
		exit(EXIT_FAILURE);
	}
	snprintf(conf.stats.logfile, sizeof(conf.stats.logfile), "%s", (yyvsp[0].string));
	free((yyvsp[0].string));
}
#line 3338 "read_config_yy.c"
    break;

  case 210: /* stat_syslog_bool: T_SYSLOG T_ON  */
#line 1404 "read_config_yy.y"
{
	conf.stats.syslog_facility = DEFAULT_SYSLOG_FACILITY;
}
#line 3346 "read_config_yy.c"
    break;

  case 211: /* stat_syslog_bool: T_SYSLOG T_OFF  */
#line 1409 "read_config_yy.y"
{
	conf.stats.syslog_facility = -1;
}
#line 3354 "read_config_yy.c"
    break;

  case 212: /* stat_syslog_facility: T_SYSLOG T_STRING  */
#line 1414 "read_config_yy.y"
{
	if (!strcmp((yyvsp[0].string), "daemon"))
		conf.stats.syslog_facility = LOG_DAEMON;
	else if (!strcmp((yyvsp[0].string), "local0"))
		conf.stats.syslog_facility = LOG_LOCAL0;
	else if (!strcmp((yyvsp[0].string), "local1"))
		conf.stats.syslog_facility = LOG_LOCAL1;
	else if (!strcmp((yyvsp[0].string), "local2"))
		conf.stats.syslog_facility = LOG_LOCAL2;
	else if (!strcmp((yyvsp[0].string), "local3"))
		conf.stats.syslog_facility = LOG_LOCAL3;
	else if (!strcmp((yyvsp[0].string), "local4"))
		conf.stats.syslog_facility = LOG_LOCAL4;
	else if (!strcmp((yyvsp[0].string), "local5"))
		conf.stats.syslog_facility = LOG_LOCAL5;
	else if (!strcmp((yyvsp[0].string), "local6"))
		conf.stats.syslog_facility = LOG_LOCAL6;
	else if (!strcmp((yyvsp[0].string), "local7"))
		conf.stats.syslog_facility = LOG_LOCAL7;
	else {
		dlog(LOG_WARNING, "'%s' is not a known syslog facility, "
		     "ignoring.", (yyvsp[0].string));
		free((yyvsp[0].string));
		break;
	}
	free((yyvsp[0].string));

	if (conf.syslog_facility != -1 &&
	    conf.stats.syslog_facility != conf.syslog_facility)
		dlog(LOG_WARNING, "conflicting Syslog facility "
		     "values, defaulting to General");
}
#line 3391 "read_config_yy.c"
    break;

  case 213: /* helper: T_HELPER '{' helper_list '}'  */
#line 1448 "read_config_yy.y"
{
	conf.flags |= CTD_HELPER;
}
#line 3399 "read_config_yy.c"
    break;

  case 217: /* helper_type: T_TYPE T_STRING T_STRING T_STRING '{' helper_type_list '}'  */
#line 1460 "read_config_yy.y"
{
	struct ctd_helper_instance *helper_inst;
	struct ctd_helper *helper;
	struct stack_item *e;
	uint16_t l3proto;
	uint8_t l4proto;

	if (strcmp((yyvsp[-4].string), "inet") == 0)
		l3proto = AF_INET;
	else if (strcmp((yyvsp[-4].string), "inet6") == 0)
		l3proto = AF_INET6;
	else {
		dlog(LOG_ERR, "unknown layer 3 protocol");
		free((yyvsp[-4].string));
		exit(EXIT_FAILURE);
	}
	free((yyvsp[-4].string));

	if (strcmp((yyvsp[-3].string), "tcp") == 0)
		l4proto = IPPROTO_TCP;
	else if (strcmp((yyvsp[-3].string), "udp") == 0)
		l4proto = IPPROTO_UDP;
	else {
		dlog(LOG_ERR, "unknown layer 4 protocol");
		free((yyvsp[-3].string));
		exit(EXIT_FAILURE);
	}
	free((yyvsp[-3].string));

#ifdef BUILD_CTHELPER
	helper = helper_find(CONNTRACKD_LIB_DIR, (yyvsp[-5].string), l4proto, RTLD_NOW);
	if (helper == NULL) {
		dlog(LOG_ERR, "Unknown `%s' helper", (yyvsp[-5].string));
		free((yyvsp[-5].string));
		exit(EXIT_FAILURE);
	}
#else
	dlog(LOG_ERR, "Helper support is disabled, recompile conntrackd");
	exit(EXIT_FAILURE);
#endif
	free((yyvsp[-5].string));

	helper_inst = calloc(1, sizeof(struct ctd_helper_instance));
	if (helper_inst == NULL)
		break;

	helper_inst->l3proto = l3proto;
	helper_inst->l4proto = l4proto;
	helper_inst->helper = helper;

	while ((e = stack_item_pop(&symbol_stack, -1)) != NULL) {

		switch(e->type) {
		case SYMBOL_HELPER_QUEUE_NUM: {
			int *qnum = (int *) &e->data;

			helper_inst->queue_num = *qnum;
			stack_item_free(e);
			break;
		}
		case SYMBOL_HELPER_QUEUE_LEN: {
			int *qlen = (int *) &e->data;

			helper_inst->queue_len = *qlen;
			stack_item_free(e);
			break;
		}
		case SYMBOL_HELPER_POLICY_EXPECT_ROOT: {
			struct ctd_helper_policy *pol =
				(struct ctd_helper_policy *) &e->data;
			struct ctd_helper_policy *matching = NULL;
			int i;

			for (i=0; i<CTD_HELPER_POLICY_MAX; i++) {
				if (strcmp(helper->policy[i].name,
					   pol->name) != 0)
					continue;

				matching = pol;
				break;
			}
			if (matching == NULL) {
				dlog(LOG_ERR, "Unknown policy `%s' in helper "
				     "configuration", pol->name);
				exit(EXIT_FAILURE);
			}
			/* FIXME: First set default policy, then change only
			 * tuned fields, not everything.
			 */
			memcpy(&helper->policy[i], pol,
				sizeof(struct ctd_helper_policy));

			stack_item_free(e);
			break;
		}
		default:
			dlog(LOG_ERR, "Unexpected symbol parsing helper "
			     "policy");
			exit(EXIT_FAILURE);
			break;
		}
	}
	list_add(&helper_inst->head, &CONFIG(cthelper).list);
}
#line 3508 "read_config_yy.c"
    break;

  case 221: /* helper_type: T_HELPER_QUEUE_NUM T_NUMBER  */
#line 1573 "read_config_yy.y"
{
	int *qnum;
	struct stack_item *e;

	e = stack_item_alloc(SYMBOL_HELPER_QUEUE_NUM, sizeof(int));
	qnum = (int *) e->data;
	*qnum = (yyvsp[0].val);
	stack_item_push(&symbol_stack, e);
}
#line 3522 "read_config_yy.c"
    break;

  case 222: /* helper_type: T_HELPER_QUEUE_LEN T_NUMBER  */
#line 1584 "read_config_yy.y"
{
	int *qlen;
	struct stack_item *e;

	e = stack_item_alloc(SYMBOL_HELPER_QUEUE_LEN, sizeof(int));
	qlen = (int *) e->data;
	*qlen = (yyvsp[0].val);
	stack_item_push(&symbol_stack, e);
}
#line 3536 "read_config_yy.c"
    break;

  case 223: /* helper_type: T_HELPER_POLICY T_STRING '{' helper_policy_list '}'  */
#line 1595 "read_config_yy.y"
{
	struct stack_item *e;
	struct ctd_helper_policy *policy;

	e = stack_item_pop(&symbol_stack, SYMBOL_HELPER_EXPECT_POLICY_LEAF);
	if (e == NULL) {
		dlog(LOG_ERR, "Helper policy configuration empty, fix your "
		     "configuration file, please");
		free((yyvsp[-3].string));
		exit(EXIT_FAILURE);
		break;
	}
	if (strlen((yyvsp[-3].string)) > CTD_HELPER_NAME_LEN) {
		dlog(LOG_ERR, "Helper Policy is longer than %u characters",
		     CTD_HELPER_NAME_LEN);
		exit(EXIT_FAILURE);
	}

	policy = (struct ctd_helper_policy *) &e->data;
	snprintf(policy->name, sizeof(policy->name), "%s", (yyvsp[-3].string));
	free((yyvsp[-3].string));
	/* Now object is complete. */
	e->type = SYMBOL_HELPER_POLICY_EXPECT_ROOT;
	stack_item_push(&symbol_stack, e);
}
#line 3566 "read_config_yy.c"
    break;

  case 228: /* helper_policy_expect_max: T_HELPER_EXPECT_MAX T_NUMBER  */
#line 1630 "read_config_yy.y"
{
	struct stack_item *e;
	struct ctd_helper_policy *policy;

	e = stack_item_pop(&symbol_stack, SYMBOL_HELPER_EXPECT_POLICY_LEAF);
	if (e == NULL) {
		e = stack_item_alloc(SYMBOL_HELPER_EXPECT_POLICY_LEAF,
				     sizeof(struct ctd_helper_policy));
	}
	policy = (struct ctd_helper_policy *) &e->data;
	policy->expect_max = (yyvsp[0].val);
	stack_item_push(&symbol_stack, e);
}
#line 3584 "read_config_yy.c"
    break;

  case 229: /* helper_policy_expect_timeout: T_HELPER_EXPECT_TIMEOUT T_NUMBER  */
#line 1645 "read_config_yy.y"
{
	struct stack_item *e;
	struct ctd_helper_policy *policy;

	e = stack_item_pop(&symbol_stack, SYMBOL_HELPER_EXPECT_POLICY_LEAF);
	if (e == NULL) {
		e = stack_item_alloc(SYMBOL_HELPER_EXPECT_POLICY_LEAF,
				     sizeof(struct ctd_helper_policy));
	}
	policy = (struct ctd_helper_policy *) &e->data;
	policy->expect_timeout = (yyvsp[0].val);
	stack_item_push(&symbol_stack, e);
}
#line 3602 "read_config_yy.c"
    break;


#line 3606 "read_config_yy.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1659 "read_config_yy.y"


int __attribute__((noreturn))
yyerror(char *msg)
{
	dlog(LOG_ERR, "parsing config file in line (%d), symbol '%s': %s",
	     yylineno, yytext, msg);
	exit(EXIT_FAILURE);
}

static void __kernel_filter_start(void)
{
	if (!STATE(filter)) {
		STATE(filter) = nfct_filter_create();
		if (!STATE(filter)) {
			dlog(LOG_ERR, "cannot create ignore pool!");
			exit(EXIT_FAILURE);
		}
	}
}

static void __kernel_filter_add_state(int value)
{
	__kernel_filter_start();

	struct nfct_filter_proto filter_proto = {
		.proto = IPPROTO_TCP,
		.state = value
	};
	nfct_filter_add_attr(STATE(filter),
			     NFCT_FILTER_L4PROTO_STATE,
			     &filter_proto);
}

static void __max_dedicated_links_reached(void)
{
	if (conf.channel_num >= MULTICHANNEL_MAX) {
		dlog(LOG_ERR, "too many dedicated links in the configuration "
		     "file (Maximum: %d)", MULTICHANNEL_MAX);
		exit(EXIT_FAILURE);
	}
}

int
init_config(char *filename)
{
	FILE *fp;

	fp = fopen(filename, "r");
	if (!fp)
		return -1;

	/* Zero may be a valid facility */
	CONFIG(syslog_facility) = -1;
	CONFIG(stats).syslog_facility = -1;
	CONFIG(netlink).subsys_id = -1;

#ifdef BUILD_SYSTEMD
        CONFIG(systemd) = 1;
#endif /* BUILD_SYSTEMD */

	/* Initialize list of user-space helpers */
	INIT_LIST_HEAD(&CONFIG(cthelper).list);

	stack_init(&symbol_stack);

	yyrestart(fp);
	yyparse();
	fclose(fp);

#ifndef BUILD_SYSTEMD
	if (CONFIG(systemd) == 1) {
		dlog(LOG_WARNING, "systemd runtime support activated but "
		     "conntrackd was built without support "
		     "for it. Recompile conntrackd");
	}
#endif /* BUILD_SYSTEMD */

	/* set to default is not specified */
	if (strcmp(CONFIG(lockfile), "") == 0)
		strncpy(CONFIG(lockfile), DEFAULT_LOCKFILE, FILENAME_MAXLEN);

	/* default to 180 seconds of expiration time: cache entries */
	if (CONFIG(cache_timeout) == 0)
		CONFIG(cache_timeout) = 180;

	/* default to 60 seconds: purge kernel entries */
	if (CONFIG(purge_timeout) == 0)
		CONFIG(purge_timeout) = 60;

	/* default to 60 seconds of refresh time */
	if (CONFIG(refresh) == 0)
		CONFIG(refresh) = 60;

	if (CONFIG(resend_queue_size) == 0)
		CONFIG(resend_queue_size) = 131072;

	/* default to a window size of 300 packets */
	if (CONFIG(window_size) == 0)
		CONFIG(window_size) = 300;

	if (CONFIG(event_iterations_limit) == 0)
		CONFIG(event_iterations_limit) = 100;

	/* default number of bucket of the hashtable that are committed in
	   one run loop. XXX: no option available to tune this value yet. */
	if (CONFIG(general).commit_steps == 0)
		CONFIG(general).commit_steps = 8192;

	/* if overrun, automatically resync with kernel after 30 seconds */
	if (CONFIG(nl_overrun_resync) == 0)
		CONFIG(nl_overrun_resync) = 30;

	/* default to 128 elements in the channel error queue */
	if (CONFIG(channelc).error_queue_length == 0)
		CONFIG(channelc).error_queue_length = 128;

	if (CONFIG(netlink).subsys_id == -1) {
		CONFIG(netlink).subsys_id = NFNL_SUBSYS_CTNETLINK;
		CONFIG(netlink).groups = NF_NETLINK_CONNTRACK_NEW |
					 NF_NETLINK_CONNTRACK_UPDATE |
					 NF_NETLINK_CONNTRACK_DESTROY;
	}

	return 0;
}
